#ifndef _H_2CB8911249E52F05EF74D84BE4003752_CameraImage__H_
#define _H_2CB8911249E52F05EF74D84BE4003752_CameraImage__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "ibeo_msgs/msg/dds_opensplice/MountingPositionF_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace CameraImage_Constants
            {
                const ::DDS::UShort JPEG_ = 0U;

                const ::DDS::UShort MJPEG_ = 1U;

                const ::DDS::UShort GRAY8_ = 2U;

                const ::DDS::UShort YUV420_ = 3U;

                const ::DDS::UShort YUV422_ = 4U;

            }

            struct  CameraImage_
            {
                struct _image_buffer__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Octet, struct _image_buffer__seq_uniq_ > _image_buffer__seq;
                typedef DDS_DCPSSequence_var< _image_buffer__seq > _image_buffer__seq_var;
                typedef DDS_DCPSSequence_out< _image_buffer__seq > _image_buffer__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::DDS::UShort image_format_;
                ::DDS::ULong us_since_power_on_;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::DDS::Octet device_id_;
                ::ibeo_msgs::msg::dds_::MountingPositionF_ mounting_position_;
                ::DDS::Double horizontal_opening_angle_;
                ::DDS::Double vertical_opening_angle_;
                ::DDS::UShort image_width_;
                ::DDS::UShort image_height_;
                ::DDS::ULong compressed_size_;
                _image_buffer__seq image_buffer_;
            };

            typedef DDS_DCPSStruct_var<CameraImage_> CameraImage__var;
            typedef DDS_DCPSStruct_out < CameraImage_> CameraImage__out;

        }

    }

}

#endif /* _H_2CB8911249E52F05EF74D84BE4003752_CameraImage__H_ */
