#ifndef H_2CB8911249E52F05EF74D84BE4003752_CameraImage_SPLTYPES_H
#define H_2CB8911249E52F05EF74D84BE4003752_CameraImage_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_CameraImage_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/MountingPositionF_SplDcps.h"



extern c_metaObject __CameraImage__ibeo_msgs__load (c_base base);

extern c_metaObject __CameraImage__ibeo_msgs_msg__load (c_base base);

extern c_metaObject __CameraImage__ibeo_msgs_msg_dds___load (c_base base);

extern c_metaObject __CameraImage__ibeo_msgs_msg_dds__CameraImage_Constants__load (c_base base);

extern const char *ibeo_msgs_msg_dds__CameraImage__metaDescriptor[];
extern const int ibeo_msgs_msg_dds__CameraImage__metaDescriptorArrLength;
extern const int ibeo_msgs_msg_dds__CameraImage__metaDescriptorLength;
extern c_metaObject __ibeo_msgs_msg_dds__CameraImage___load (c_base base);
struct _ibeo_msgs_msg_dds__CameraImage_ ;
extern  v_copyin_result __ibeo_msgs_msg_dds__CameraImage___copyIn(c_base base, const struct ibeo_msgs::msg::dds_::CameraImage_ *from, struct _ibeo_msgs_msg_dds__CameraImage_ *to);
extern  void __ibeo_msgs_msg_dds__CameraImage___copyOut(const void *_from, void *_to);
struct _ibeo_msgs_msg_dds__CameraImage_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _ibeo_msgs_msg_dds__IbeoDataHeader_ ibeo_header_;
    c_ushort image_format_;
    c_ulong us_since_power_on_;
    struct _builtin_interfaces_msg_dds__Time_ timestamp_;
    c_octet device_id_;
    struct _ibeo_msgs_msg_dds__MountingPositionF_ mounting_position_;
    c_double horizontal_opening_angle_;
    c_double vertical_opening_angle_;
    c_ushort image_width_;
    c_ushort image_height_;
    c_ulong compressed_size_;
    c_sequence image_buffer_;
};

#undef OS_API
#endif
