#ifndef _H_E3ABEE52CB50A3E76748ACB8FE3D637F_ContourPointSigma_DCPS_H_
#define _H_E3ABEE52CB50A3E76748ACB8FE3D637F_ContourPointSigma_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ContourPointSigma_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ContourPointSigma_TypeSupportInterface;

            typedef ContourPointSigma_TypeSupportInterface * ContourPointSigma_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ContourPointSigma_TypeSupportInterface> ContourPointSigma_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ContourPointSigma_TypeSupportInterface> ContourPointSigma_TypeSupportInterface_out;


            class ContourPointSigma_DataWriter;

            typedef ContourPointSigma_DataWriter * ContourPointSigma_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ContourPointSigma_DataWriter> ContourPointSigma_DataWriter_var;
            typedef DDS_DCPSInterface_out < ContourPointSigma_DataWriter> ContourPointSigma_DataWriter_out;


            class ContourPointSigma_DataReader;

            typedef ContourPointSigma_DataReader * ContourPointSigma_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ContourPointSigma_DataReader> ContourPointSigma_DataReader_var;
            typedef DDS_DCPSInterface_out < ContourPointSigma_DataReader> ContourPointSigma_DataReader_out;


            class ContourPointSigma_DataReaderView;

            typedef ContourPointSigma_DataReaderView * ContourPointSigma_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ContourPointSigma_DataReaderView> ContourPointSigma_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ContourPointSigma_DataReaderView> ContourPointSigma_DataReaderView_out;

            struct ContourPointSigma_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ContourPointSigma_, struct ContourPointSigma_Seq_uniq_> ContourPointSigma_Seq;
            typedef DDS_DCPSSequence_var < ContourPointSigma_Seq> ContourPointSigma_Seq_var;
            typedef DDS_DCPSSequence_out < ContourPointSigma_Seq> ContourPointSigma_Seq_out;

            class  ContourPointSigma_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ContourPointSigma_TypeSupportInterface_ptr _ptr_type;
                typedef ContourPointSigma_TypeSupportInterface_var _var_type;

                static ContourPointSigma_TypeSupportInterface_ptr _duplicate (ContourPointSigma_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ContourPointSigma_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ContourPointSigma_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ContourPointSigma_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ContourPointSigma_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ContourPointSigma_TypeSupportInterface () {};
                ~ContourPointSigma_TypeSupportInterface () {};
            private:
                ContourPointSigma_TypeSupportInterface (const ContourPointSigma_TypeSupportInterface &);
                ContourPointSigma_TypeSupportInterface & operator = (const ContourPointSigma_TypeSupportInterface &);
            };

            class  ContourPointSigma_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ContourPointSigma_DataWriter_ptr _ptr_type;
                typedef ContourPointSigma_DataWriter_var _var_type;

                static ContourPointSigma_DataWriter_ptr _duplicate (ContourPointSigma_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ContourPointSigma_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ContourPointSigma_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ContourPointSigma_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ContourPointSigma_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ContourPointSigma_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ContourPointSigma_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ContourPointSigma_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ContourPointSigma_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ContourPointSigma_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ContourPointSigma_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ContourPointSigma_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ContourPointSigma_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ContourPointSigma_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ContourPointSigma_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ContourPointSigma_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ContourPointSigma_& instance_data) = 0;

            protected:
                ContourPointSigma_DataWriter () {};
                ~ContourPointSigma_DataWriter () {};
            private:
                ContourPointSigma_DataWriter (const ContourPointSigma_DataWriter &);
                ContourPointSigma_DataWriter & operator = (const ContourPointSigma_DataWriter &);
            };

            class  ContourPointSigma_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ContourPointSigma_DataReader_ptr _ptr_type;
                typedef ContourPointSigma_DataReader_var _var_type;

                static ContourPointSigma_DataReader_ptr _duplicate (ContourPointSigma_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ContourPointSigma_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ContourPointSigma_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ContourPointSigma_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ContourPointSigma_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ContourPointSigma_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ContourPointSigma_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ContourPointSigma_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ContourPointSigma_& instance) = 0;

            protected:
                ContourPointSigma_DataReader () {};
                ~ContourPointSigma_DataReader () {};
            private:
                ContourPointSigma_DataReader (const ContourPointSigma_DataReader &);
                ContourPointSigma_DataReader & operator = (const ContourPointSigma_DataReader &);
            };

            class  ContourPointSigma_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ContourPointSigma_DataReaderView_ptr _ptr_type;
                typedef ContourPointSigma_DataReaderView_var _var_type;

                static ContourPointSigma_DataReaderView_ptr _duplicate (ContourPointSigma_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ContourPointSigma_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ContourPointSigma_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ContourPointSigma_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ContourPointSigma_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ContourPointSigma_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ContourPointSigma_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ContourPointSigma_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ContourPointSigma_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ContourPointSigma_& instance) = 0;

            protected:
                ContourPointSigma_DataReaderView () {};
                ~ContourPointSigma_DataReaderView () {};
            private:
                ContourPointSigma_DataReaderView (const ContourPointSigma_DataReaderView &);
                ContourPointSigma_DataReaderView & operator = (const ContourPointSigma_DataReaderView &);
            };
        }

    }

}

#endif
