#ifndef _H_F3F43BBD2A8DD3741FE732D7F2941F1F_DeviceStatus__H_
#define _H_F3F43BBD2A8DD3741FE732D7F2941F1F_DeviceStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  DeviceStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::DDS::Octet scanner_type_;
                ::DDS::Float sensor_temperature_;
                ::DDS::Float frequency_;
            };

            typedef DDS_DCPSStruct_var<DeviceStatus_> DeviceStatus__var;
            typedef DDS_DCPSStruct_out < DeviceStatus_> DeviceStatus__out;

        }

    }

}

#endif /* _H_F3F43BBD2A8DD3741FE732D7F2941F1F_DeviceStatus__H_ */
