#ifndef _H_F3F43BBD2A8DD3741FE732D7F2941F1F_DeviceStatus_DCPS_H_
#define _H_F3F43BBD2A8DD3741FE732D7F2941F1F_DeviceStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeviceStatus_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DeviceStatus_TypeSupportInterface;

            typedef DeviceStatus_TypeSupportInterface * DeviceStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeviceStatus_TypeSupportInterface> DeviceStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeviceStatus_TypeSupportInterface> DeviceStatus_TypeSupportInterface_out;


            class DeviceStatus_DataWriter;

            typedef DeviceStatus_DataWriter * DeviceStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeviceStatus_DataWriter> DeviceStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeviceStatus_DataWriter> DeviceStatus_DataWriter_out;


            class DeviceStatus_DataReader;

            typedef DeviceStatus_DataReader * DeviceStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeviceStatus_DataReader> DeviceStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < DeviceStatus_DataReader> DeviceStatus_DataReader_out;


            class DeviceStatus_DataReaderView;

            typedef DeviceStatus_DataReaderView * DeviceStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeviceStatus_DataReaderView> DeviceStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeviceStatus_DataReaderView> DeviceStatus_DataReaderView_out;

            struct DeviceStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeviceStatus_, struct DeviceStatus_Seq_uniq_> DeviceStatus_Seq;
            typedef DDS_DCPSSequence_var < DeviceStatus_Seq> DeviceStatus_Seq_var;
            typedef DDS_DCPSSequence_out < DeviceStatus_Seq> DeviceStatus_Seq_out;

            class  DeviceStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeviceStatus_TypeSupportInterface_ptr _ptr_type;
                typedef DeviceStatus_TypeSupportInterface_var _var_type;

                static DeviceStatus_TypeSupportInterface_ptr _duplicate (DeviceStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeviceStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeviceStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeviceStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeviceStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeviceStatus_TypeSupportInterface () {};
                ~DeviceStatus_TypeSupportInterface () {};
            private:
                DeviceStatus_TypeSupportInterface (const DeviceStatus_TypeSupportInterface &);
                DeviceStatus_TypeSupportInterface & operator = (const DeviceStatus_TypeSupportInterface &);
            };

            class  DeviceStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeviceStatus_DataWriter_ptr _ptr_type;
                typedef DeviceStatus_DataWriter_var _var_type;

                static DeviceStatus_DataWriter_ptr _duplicate (DeviceStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeviceStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeviceStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeviceStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeviceStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeviceStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeviceStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeviceStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeviceStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeviceStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeviceStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeviceStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeviceStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeviceStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeviceStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeviceStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeviceStatus_& instance_data) = 0;

            protected:
                DeviceStatus_DataWriter () {};
                ~DeviceStatus_DataWriter () {};
            private:
                DeviceStatus_DataWriter (const DeviceStatus_DataWriter &);
                DeviceStatus_DataWriter & operator = (const DeviceStatus_DataWriter &);
            };

            class  DeviceStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeviceStatus_DataReader_ptr _ptr_type;
                typedef DeviceStatus_DataReader_var _var_type;

                static DeviceStatus_DataReader_ptr _duplicate (DeviceStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeviceStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeviceStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeviceStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeviceStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeviceStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeviceStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeviceStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeviceStatus_& instance) = 0;

            protected:
                DeviceStatus_DataReader () {};
                ~DeviceStatus_DataReader () {};
            private:
                DeviceStatus_DataReader (const DeviceStatus_DataReader &);
                DeviceStatus_DataReader & operator = (const DeviceStatus_DataReader &);
            };

            class  DeviceStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeviceStatus_DataReaderView_ptr _ptr_type;
                typedef DeviceStatus_DataReaderView_var _var_type;

                static DeviceStatus_DataReaderView_ptr _duplicate (DeviceStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeviceStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeviceStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeviceStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeviceStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeviceStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeviceStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeviceStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeviceStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeviceStatus_& instance) = 0;

            protected:
                DeviceStatus_DataReaderView () {};
                ~DeviceStatus_DataReaderView () {};
            private:
                DeviceStatus_DataReaderView (const DeviceStatus_DataReaderView &);
                DeviceStatus_DataReaderView & operator = (const DeviceStatus_DataReaderView &);
            };
        }

    }

}

#endif
