#ifndef _H_5C7735B8495BA5C1BC8F979FEBD9EEF0_ErrorWarning_DCPS_H_
#define _H_5C7735B8495BA5C1BC8F979FEBD9EEF0_ErrorWarning_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ErrorWarning_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ErrorWarning_TypeSupportInterface;

            typedef ErrorWarning_TypeSupportInterface * ErrorWarning_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ErrorWarning_TypeSupportInterface> ErrorWarning_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ErrorWarning_TypeSupportInterface> ErrorWarning_TypeSupportInterface_out;


            class ErrorWarning_DataWriter;

            typedef ErrorWarning_DataWriter * ErrorWarning_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ErrorWarning_DataWriter> ErrorWarning_DataWriter_var;
            typedef DDS_DCPSInterface_out < ErrorWarning_DataWriter> ErrorWarning_DataWriter_out;


            class ErrorWarning_DataReader;

            typedef ErrorWarning_DataReader * ErrorWarning_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ErrorWarning_DataReader> ErrorWarning_DataReader_var;
            typedef DDS_DCPSInterface_out < ErrorWarning_DataReader> ErrorWarning_DataReader_out;


            class ErrorWarning_DataReaderView;

            typedef ErrorWarning_DataReaderView * ErrorWarning_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ErrorWarning_DataReaderView> ErrorWarning_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ErrorWarning_DataReaderView> ErrorWarning_DataReaderView_out;

            struct ErrorWarning_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ErrorWarning_, struct ErrorWarning_Seq_uniq_> ErrorWarning_Seq;
            typedef DDS_DCPSSequence_var < ErrorWarning_Seq> ErrorWarning_Seq_var;
            typedef DDS_DCPSSequence_out < ErrorWarning_Seq> ErrorWarning_Seq_out;

            class  ErrorWarning_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ErrorWarning_TypeSupportInterface_ptr _ptr_type;
                typedef ErrorWarning_TypeSupportInterface_var _var_type;

                static ErrorWarning_TypeSupportInterface_ptr _duplicate (ErrorWarning_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ErrorWarning_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ErrorWarning_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ErrorWarning_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ErrorWarning_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ErrorWarning_TypeSupportInterface () {};
                ~ErrorWarning_TypeSupportInterface () {};
            private:
                ErrorWarning_TypeSupportInterface (const ErrorWarning_TypeSupportInterface &);
                ErrorWarning_TypeSupportInterface & operator = (const ErrorWarning_TypeSupportInterface &);
            };

            class  ErrorWarning_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ErrorWarning_DataWriter_ptr _ptr_type;
                typedef ErrorWarning_DataWriter_var _var_type;

                static ErrorWarning_DataWriter_ptr _duplicate (ErrorWarning_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ErrorWarning_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ErrorWarning_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ErrorWarning_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ErrorWarning_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ErrorWarning_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ErrorWarning_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ErrorWarning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ErrorWarning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ErrorWarning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ErrorWarning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ErrorWarning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ErrorWarning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ErrorWarning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ErrorWarning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ErrorWarning_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ErrorWarning_& instance_data) = 0;

            protected:
                ErrorWarning_DataWriter () {};
                ~ErrorWarning_DataWriter () {};
            private:
                ErrorWarning_DataWriter (const ErrorWarning_DataWriter &);
                ErrorWarning_DataWriter & operator = (const ErrorWarning_DataWriter &);
            };

            class  ErrorWarning_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ErrorWarning_DataReader_ptr _ptr_type;
                typedef ErrorWarning_DataReader_var _var_type;

                static ErrorWarning_DataReader_ptr _duplicate (ErrorWarning_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ErrorWarning_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ErrorWarning_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ErrorWarning_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ErrorWarning_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ErrorWarning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ErrorWarning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ErrorWarning_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ErrorWarning_& instance) = 0;

            protected:
                ErrorWarning_DataReader () {};
                ~ErrorWarning_DataReader () {};
            private:
                ErrorWarning_DataReader (const ErrorWarning_DataReader &);
                ErrorWarning_DataReader & operator = (const ErrorWarning_DataReader &);
            };

            class  ErrorWarning_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ErrorWarning_DataReaderView_ptr _ptr_type;
                typedef ErrorWarning_DataReaderView_var _var_type;

                static ErrorWarning_DataReaderView_ptr _duplicate (ErrorWarning_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ErrorWarning_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ErrorWarning_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ErrorWarning_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ErrorWarning_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ErrorWarning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ErrorWarning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ErrorWarning_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ErrorWarning_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ErrorWarning_& instance) = 0;

            protected:
                ErrorWarning_DataReaderView () {};
                ~ErrorWarning_DataReaderView () {};
            private:
                ErrorWarning_DataReaderView (const ErrorWarning_DataReaderView &);
                ErrorWarning_DataReaderView & operator = (const ErrorWarning_DataReaderView &);
            };
        }

    }

}

#endif
