#ifndef _H_BFC29E1B99BD4CB027966CE4FB05C8A8_HostVehicleState2807_DCPS_H_
#define _H_BFC29E1B99BD4CB027966CE4FB05C8A8_HostVehicleState2807_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HostVehicleState2807_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HostVehicleState2807_TypeSupportInterface;

            typedef HostVehicleState2807_TypeSupportInterface * HostVehicleState2807_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HostVehicleState2807_TypeSupportInterface> HostVehicleState2807_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HostVehicleState2807_TypeSupportInterface> HostVehicleState2807_TypeSupportInterface_out;


            class HostVehicleState2807_DataWriter;

            typedef HostVehicleState2807_DataWriter * HostVehicleState2807_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HostVehicleState2807_DataWriter> HostVehicleState2807_DataWriter_var;
            typedef DDS_DCPSInterface_out < HostVehicleState2807_DataWriter> HostVehicleState2807_DataWriter_out;


            class HostVehicleState2807_DataReader;

            typedef HostVehicleState2807_DataReader * HostVehicleState2807_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HostVehicleState2807_DataReader> HostVehicleState2807_DataReader_var;
            typedef DDS_DCPSInterface_out < HostVehicleState2807_DataReader> HostVehicleState2807_DataReader_out;


            class HostVehicleState2807_DataReaderView;

            typedef HostVehicleState2807_DataReaderView * HostVehicleState2807_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HostVehicleState2807_DataReaderView> HostVehicleState2807_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HostVehicleState2807_DataReaderView> HostVehicleState2807_DataReaderView_out;

            struct HostVehicleState2807_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HostVehicleState2807_, struct HostVehicleState2807_Seq_uniq_> HostVehicleState2807_Seq;
            typedef DDS_DCPSSequence_var < HostVehicleState2807_Seq> HostVehicleState2807_Seq_var;
            typedef DDS_DCPSSequence_out < HostVehicleState2807_Seq> HostVehicleState2807_Seq_out;

            class  HostVehicleState2807_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HostVehicleState2807_TypeSupportInterface_ptr _ptr_type;
                typedef HostVehicleState2807_TypeSupportInterface_var _var_type;

                static HostVehicleState2807_TypeSupportInterface_ptr _duplicate (HostVehicleState2807_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HostVehicleState2807_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HostVehicleState2807_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HostVehicleState2807_TypeSupportInterface () {};
                ~HostVehicleState2807_TypeSupportInterface () {};
            private:
                HostVehicleState2807_TypeSupportInterface (const HostVehicleState2807_TypeSupportInterface &);
                HostVehicleState2807_TypeSupportInterface & operator = (const HostVehicleState2807_TypeSupportInterface &);
            };

            class  HostVehicleState2807_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HostVehicleState2807_DataWriter_ptr _ptr_type;
                typedef HostVehicleState2807_DataWriter_var _var_type;

                static HostVehicleState2807_DataWriter_ptr _duplicate (HostVehicleState2807_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HostVehicleState2807_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HostVehicleState2807_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HostVehicleState2807_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HostVehicleState2807_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HostVehicleState2807_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HostVehicleState2807_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HostVehicleState2807_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HostVehicleState2807_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HostVehicleState2807_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HostVehicleState2807_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HostVehicleState2807_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HostVehicleState2807_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HostVehicleState2807_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HostVehicleState2807_& instance_data) = 0;

            protected:
                HostVehicleState2807_DataWriter () {};
                ~HostVehicleState2807_DataWriter () {};
            private:
                HostVehicleState2807_DataWriter (const HostVehicleState2807_DataWriter &);
                HostVehicleState2807_DataWriter & operator = (const HostVehicleState2807_DataWriter &);
            };

            class  HostVehicleState2807_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HostVehicleState2807_DataReader_ptr _ptr_type;
                typedef HostVehicleState2807_DataReader_var _var_type;

                static HostVehicleState2807_DataReader_ptr _duplicate (HostVehicleState2807_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HostVehicleState2807_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HostVehicleState2807_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HostVehicleState2807_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HostVehicleState2807_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HostVehicleState2807_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HostVehicleState2807_& instance) = 0;

            protected:
                HostVehicleState2807_DataReader () {};
                ~HostVehicleState2807_DataReader () {};
            private:
                HostVehicleState2807_DataReader (const HostVehicleState2807_DataReader &);
                HostVehicleState2807_DataReader & operator = (const HostVehicleState2807_DataReader &);
            };

            class  HostVehicleState2807_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HostVehicleState2807_DataReaderView_ptr _ptr_type;
                typedef HostVehicleState2807_DataReaderView_var _var_type;

                static HostVehicleState2807_DataReaderView_ptr _duplicate (HostVehicleState2807_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HostVehicleState2807_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HostVehicleState2807_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HostVehicleState2807_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HostVehicleState2807_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HostVehicleState2807_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HostVehicleState2807_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HostVehicleState2807_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HostVehicleState2807_& instance) = 0;

            protected:
                HostVehicleState2807_DataReaderView () {};
                ~HostVehicleState2807_DataReaderView () {};
            private:
                HostVehicleState2807_DataReaderView (const HostVehicleState2807_DataReaderView &);
                HostVehicleState2807_DataReaderView & operator = (const HostVehicleState2807_DataReaderView &);
            };
        }

    }

}

#endif
