#ifndef _H_C071D87CF488D5395E81C82B576E31F8_MountingPositionF_DCPS_H_
#define _H_C071D87CF488D5395E81C82B576E31F8_MountingPositionF_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MountingPositionF_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MountingPositionF_TypeSupportInterface;

            typedef MountingPositionF_TypeSupportInterface * MountingPositionF_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MountingPositionF_TypeSupportInterface> MountingPositionF_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MountingPositionF_TypeSupportInterface> MountingPositionF_TypeSupportInterface_out;


            class MountingPositionF_DataWriter;

            typedef MountingPositionF_DataWriter * MountingPositionF_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MountingPositionF_DataWriter> MountingPositionF_DataWriter_var;
            typedef DDS_DCPSInterface_out < MountingPositionF_DataWriter> MountingPositionF_DataWriter_out;


            class MountingPositionF_DataReader;

            typedef MountingPositionF_DataReader * MountingPositionF_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MountingPositionF_DataReader> MountingPositionF_DataReader_var;
            typedef DDS_DCPSInterface_out < MountingPositionF_DataReader> MountingPositionF_DataReader_out;


            class MountingPositionF_DataReaderView;

            typedef MountingPositionF_DataReaderView * MountingPositionF_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MountingPositionF_DataReaderView> MountingPositionF_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MountingPositionF_DataReaderView> MountingPositionF_DataReaderView_out;

            struct MountingPositionF_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < MountingPositionF_, struct MountingPositionF_Seq_uniq_> MountingPositionF_Seq;
            typedef DDS_DCPSSequence_var < MountingPositionF_Seq> MountingPositionF_Seq_var;
            typedef DDS_DCPSSequence_out < MountingPositionF_Seq> MountingPositionF_Seq_out;

            class  MountingPositionF_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MountingPositionF_TypeSupportInterface_ptr _ptr_type;
                typedef MountingPositionF_TypeSupportInterface_var _var_type;

                static MountingPositionF_TypeSupportInterface_ptr _duplicate (MountingPositionF_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountingPositionF_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MountingPositionF_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountingPositionF_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MountingPositionF_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MountingPositionF_TypeSupportInterface () {};
                ~MountingPositionF_TypeSupportInterface () {};
            private:
                MountingPositionF_TypeSupportInterface (const MountingPositionF_TypeSupportInterface &);
                MountingPositionF_TypeSupportInterface & operator = (const MountingPositionF_TypeSupportInterface &);
            };

            class  MountingPositionF_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MountingPositionF_DataWriter_ptr _ptr_type;
                typedef MountingPositionF_DataWriter_var _var_type;

                static MountingPositionF_DataWriter_ptr _duplicate (MountingPositionF_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountingPositionF_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MountingPositionF_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountingPositionF_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MountingPositionF_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MountingPositionF_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MountingPositionF_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MountingPositionF_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MountingPositionF_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MountingPositionF_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MountingPositionF_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MountingPositionF_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MountingPositionF_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MountingPositionF_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MountingPositionF_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MountingPositionF_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MountingPositionF_& instance_data) = 0;

            protected:
                MountingPositionF_DataWriter () {};
                ~MountingPositionF_DataWriter () {};
            private:
                MountingPositionF_DataWriter (const MountingPositionF_DataWriter &);
                MountingPositionF_DataWriter & operator = (const MountingPositionF_DataWriter &);
            };

            class  MountingPositionF_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MountingPositionF_DataReader_ptr _ptr_type;
                typedef MountingPositionF_DataReader_var _var_type;

                static MountingPositionF_DataReader_ptr _duplicate (MountingPositionF_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountingPositionF_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MountingPositionF_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountingPositionF_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MountingPositionF_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MountingPositionF_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MountingPositionF_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MountingPositionF_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MountingPositionF_& instance) = 0;

            protected:
                MountingPositionF_DataReader () {};
                ~MountingPositionF_DataReader () {};
            private:
                MountingPositionF_DataReader (const MountingPositionF_DataReader &);
                MountingPositionF_DataReader & operator = (const MountingPositionF_DataReader &);
            };

            class  MountingPositionF_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MountingPositionF_DataReaderView_ptr _ptr_type;
                typedef MountingPositionF_DataReaderView_var _var_type;

                static MountingPositionF_DataReaderView_ptr _duplicate (MountingPositionF_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MountingPositionF_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MountingPositionF_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MountingPositionF_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MountingPositionF_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MountingPositionF_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MountingPositionF_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MountingPositionF_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MountingPositionF_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MountingPositionF_& instance) = 0;

            protected:
                MountingPositionF_DataReaderView () {};
                ~MountingPositionF_DataReaderView () {};
            private:
                MountingPositionF_DataReaderView (const MountingPositionF_DataReaderView &);
                MountingPositionF_DataReaderView & operator = (const MountingPositionF_DataReaderView &);
            };
        }

    }

}

#endif
