#ifndef _H_E59D92952EBD9560EF52266099926693_Object2270__H_
#define _H_E59D92952EBD9560EF52266099926693_Object2270__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "ibeo_msgs/msg/dds_opensplice/Point2Di_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Object2270_Constants
            {
                const ::DDS::Octet CENTER_OF_GRAVITY_ = 0;

                const ::DDS::Octet TOP_FRONT_LEFT_CORNER_ = 1;

                const ::DDS::Octet TOP_FRONT_RIGHT_CORNER_ = 2;

                const ::DDS::Octet BOTTOM_REAR_RIGHT_CORNER_ = 3;

                const ::DDS::Octet BOTTOM_REAR_LEFT_CORNER_ = 4;

                const ::DDS::Octet CENTER_OF_TOP_FRONT_EDGE_ = 5;

                const ::DDS::Octet CENTER_OF_RIGHT_EDGE_ = 6;

                const ::DDS::Octet CENTER_OF_BOTTOM_REAR_EDGE_ = 7;

                const ::DDS::Octet CENTER_OF_LEFT_EDGE_ = 8;

                const ::DDS::Octet BOX_CENTER_ = 9;

                const ::DDS::Octet INVALID_ = 255;

                const ::DDS::Octet UNCLASSIFIED_ = 0;

                const ::DDS::Octet UNKNOWN_SMALL_ = 1;

                const ::DDS::Octet UNKNOWN_BIG_ = 2;

                const ::DDS::Octet PEDESTRIAN_ = 3;

                const ::DDS::Octet BIKE_ = 4;

                const ::DDS::Octet CAR_ = 5;

                const ::DDS::Octet TRUCK_ = 6;

                const ::DDS::Octet OVER_DRIVABLE_ = 10;

                const ::DDS::Octet UNDER_DRIVABLE_ = 11;

                const ::DDS::Octet DYNAMIC_MODEL_ = 0;

                const ::DDS::Octet STATIC_MODEL_ = 1;

            }

            struct  Object2270_
            {
                struct _contour_point_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::Point2Di_, struct _contour_point_list__seq_uniq_ > _contour_point_list__seq;
                typedef DDS_DCPSSequence_var< _contour_point_list__seq > _contour_point_list__seq_var;
                typedef DDS_DCPSSequence_out< _contour_point_list__seq > _contour_point_list__seq_out;
                ::DDS::UShort id_;
                ::DDS::UShort age_;
                ::DDS::UShort prediction_age_;
                ::DDS::UShort relative_moment_of_measurement_;
                ::DDS::Octet reference_point_location_;
                ::DDS::Short reference_point_position_x_;
                ::DDS::Short reference_point_position_y_;
                ::DDS::UShort reference_point_position_sigma_x_;
                ::DDS::UShort reference_point_position_sigma_y_;
                ::DDS::Short contour_points_cog_x_;
                ::DDS::Short contour_points_cog_y_;
                ::DDS::UShort object_box_length_;
                ::DDS::UShort object_box_width_;
                ::DDS::Short object_box_orientation_angle_;
                ::DDS::Short object_box_orientation_angle_sigma_;
                ::DDS::Short absolute_velocity_x_;
                ::DDS::Short absolute_velocity_y_;
                ::DDS::UShort absolute_velocity_sigma_x_;
                ::DDS::UShort absolute_velocity_sigma_y_;
                ::DDS::Short relative_velocity_x_;
                ::DDS::Short relative_velocity_y_;
                ::DDS::UShort relative_velocity_sigma_x_;
                ::DDS::UShort relative_velocity_sigma_y_;
                ::DDS::Octet classification_;
                ::DDS::Octet tracking_model_;
                ::DDS::Boolean mobile_detected_;
                ::DDS::Boolean track_valid_;
                ::DDS::UShort classification_age_;
                ::DDS::UShort classification_confidence_;
                ::DDS::UShort number_of_contour_points_;
                _contour_point_list__seq contour_point_list_;
            };

            typedef DDS_DCPSStruct_var<Object2270_> Object2270__var;
            typedef DDS_DCPSStruct_out < Object2270_> Object2270__out;

        }

    }

}

#endif /* _H_E59D92952EBD9560EF52266099926693_Object2270__H_ */
