#ifndef _H_E59D92952EBD9560EF52266099926693_Object2270_DCPS_H_
#define _H_E59D92952EBD9560EF52266099926693_Object2270_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Object2270_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Object2270_TypeSupportInterface;

            typedef Object2270_TypeSupportInterface * Object2270_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Object2270_TypeSupportInterface> Object2270_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Object2270_TypeSupportInterface> Object2270_TypeSupportInterface_out;


            class Object2270_DataWriter;

            typedef Object2270_DataWriter * Object2270_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Object2270_DataWriter> Object2270_DataWriter_var;
            typedef DDS_DCPSInterface_out < Object2270_DataWriter> Object2270_DataWriter_out;


            class Object2270_DataReader;

            typedef Object2270_DataReader * Object2270_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Object2270_DataReader> Object2270_DataReader_var;
            typedef DDS_DCPSInterface_out < Object2270_DataReader> Object2270_DataReader_out;


            class Object2270_DataReaderView;

            typedef Object2270_DataReaderView * Object2270_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Object2270_DataReaderView> Object2270_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Object2270_DataReaderView> Object2270_DataReaderView_out;

            struct Object2270_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Object2270_, struct Object2270_Seq_uniq_> Object2270_Seq;
            typedef DDS_DCPSSequence_var < Object2270_Seq> Object2270_Seq_var;
            typedef DDS_DCPSSequence_out < Object2270_Seq> Object2270_Seq_out;

            class  Object2270_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Object2270_TypeSupportInterface_ptr _ptr_type;
                typedef Object2270_TypeSupportInterface_var _var_type;

                static Object2270_TypeSupportInterface_ptr _duplicate (Object2270_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2270_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Object2270_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2270_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2270_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Object2270_TypeSupportInterface () {};
                ~Object2270_TypeSupportInterface () {};
            private:
                Object2270_TypeSupportInterface (const Object2270_TypeSupportInterface &);
                Object2270_TypeSupportInterface & operator = (const Object2270_TypeSupportInterface &);
            };

            class  Object2270_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Object2270_DataWriter_ptr _ptr_type;
                typedef Object2270_DataWriter_var _var_type;

                static Object2270_DataWriter_ptr _duplicate (Object2270_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2270_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Object2270_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2270_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2270_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Object2270_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Object2270_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Object2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Object2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Object2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Object2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Object2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Object2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Object2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Object2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Object2270_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Object2270_& instance_data) = 0;

            protected:
                Object2270_DataWriter () {};
                ~Object2270_DataWriter () {};
            private:
                Object2270_DataWriter (const Object2270_DataWriter &);
                Object2270_DataWriter & operator = (const Object2270_DataWriter &);
            };

            class  Object2270_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Object2270_DataReader_ptr _ptr_type;
                typedef Object2270_DataReader_var _var_type;

                static Object2270_DataReader_ptr _duplicate (Object2270_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2270_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Object2270_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2270_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2270_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Object2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Object2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Object2270_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Object2270_& instance) = 0;

            protected:
                Object2270_DataReader () {};
                ~Object2270_DataReader () {};
            private:
                Object2270_DataReader (const Object2270_DataReader &);
                Object2270_DataReader & operator = (const Object2270_DataReader &);
            };

            class  Object2270_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Object2270_DataReaderView_ptr _ptr_type;
                typedef Object2270_DataReaderView_var _var_type;

                static Object2270_DataReaderView_ptr _duplicate (Object2270_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2270_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Object2270_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2270_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2270_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Object2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Object2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Object2270_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Object2270_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Object2270_& instance) = 0;

            protected:
                Object2270_DataReaderView () {};
                ~Object2270_DataReaderView () {};
            private:
                Object2270_DataReaderView (const Object2270_DataReaderView &);
                Object2270_DataReaderView & operator = (const Object2270_DataReaderView &);
            };
        }

    }

}

#endif
