#ifndef _H_4B1DBCD55DFF81E1A51314DA8A242171_ObjectData2221_DCPS_H_
#define _H_4B1DBCD55DFF81E1A51314DA8A242171_ObjectData2221_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObjectData2221_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObjectData2221_TypeSupportInterface;

            typedef ObjectData2221_TypeSupportInterface * ObjectData2221_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2221_TypeSupportInterface> ObjectData2221_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObjectData2221_TypeSupportInterface> ObjectData2221_TypeSupportInterface_out;


            class ObjectData2221_DataWriter;

            typedef ObjectData2221_DataWriter * ObjectData2221_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2221_DataWriter> ObjectData2221_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObjectData2221_DataWriter> ObjectData2221_DataWriter_out;


            class ObjectData2221_DataReader;

            typedef ObjectData2221_DataReader * ObjectData2221_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2221_DataReader> ObjectData2221_DataReader_var;
            typedef DDS_DCPSInterface_out < ObjectData2221_DataReader> ObjectData2221_DataReader_out;


            class ObjectData2221_DataReaderView;

            typedef ObjectData2221_DataReaderView * ObjectData2221_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2221_DataReaderView> ObjectData2221_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObjectData2221_DataReaderView> ObjectData2221_DataReaderView_out;

            struct ObjectData2221_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObjectData2221_, struct ObjectData2221_Seq_uniq_> ObjectData2221_Seq;
            typedef DDS_DCPSSequence_var < ObjectData2221_Seq> ObjectData2221_Seq_var;
            typedef DDS_DCPSSequence_out < ObjectData2221_Seq> ObjectData2221_Seq_out;

            class  ObjectData2221_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObjectData2221_TypeSupportInterface_ptr _ptr_type;
                typedef ObjectData2221_TypeSupportInterface_var _var_type;

                static ObjectData2221_TypeSupportInterface_ptr _duplicate (ObjectData2221_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2221_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2221_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2221_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2221_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObjectData2221_TypeSupportInterface () {};
                ~ObjectData2221_TypeSupportInterface () {};
            private:
                ObjectData2221_TypeSupportInterface (const ObjectData2221_TypeSupportInterface &);
                ObjectData2221_TypeSupportInterface & operator = (const ObjectData2221_TypeSupportInterface &);
            };

            class  ObjectData2221_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObjectData2221_DataWriter_ptr _ptr_type;
                typedef ObjectData2221_DataWriter_var _var_type;

                static ObjectData2221_DataWriter_ptr _duplicate (ObjectData2221_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2221_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2221_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2221_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2221_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObjectData2221_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObjectData2221_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObjectData2221_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObjectData2221_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObjectData2221_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObjectData2221_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObjectData2221_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObjectData2221_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObjectData2221_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObjectData2221_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObjectData2221_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2221_& instance_data) = 0;

            protected:
                ObjectData2221_DataWriter () {};
                ~ObjectData2221_DataWriter () {};
            private:
                ObjectData2221_DataWriter (const ObjectData2221_DataWriter &);
                ObjectData2221_DataWriter & operator = (const ObjectData2221_DataWriter &);
            };

            class  ObjectData2221_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObjectData2221_DataReader_ptr _ptr_type;
                typedef ObjectData2221_DataReader_var _var_type;

                static ObjectData2221_DataReader_ptr _duplicate (ObjectData2221_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2221_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2221_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2221_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2221_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2221_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2221_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2221_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2221_& instance) = 0;

            protected:
                ObjectData2221_DataReader () {};
                ~ObjectData2221_DataReader () {};
            private:
                ObjectData2221_DataReader (const ObjectData2221_DataReader &);
                ObjectData2221_DataReader & operator = (const ObjectData2221_DataReader &);
            };

            class  ObjectData2221_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObjectData2221_DataReaderView_ptr _ptr_type;
                typedef ObjectData2221_DataReaderView_var _var_type;

                static ObjectData2221_DataReaderView_ptr _duplicate (ObjectData2221_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2221_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2221_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2221_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2221_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2221_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2221_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2221_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2221_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2221_& instance) = 0;

            protected:
                ObjectData2221_DataReaderView () {};
                ~ObjectData2221_DataReaderView () {};
            private:
                ObjectData2221_DataReaderView (const ObjectData2221_DataReaderView &);
                ObjectData2221_DataReaderView & operator = (const ObjectData2221_DataReaderView &);
            };
        }

    }

}

#endif
