#ifndef _H_9A7C02A5AC8248611A0BF78E82A847E4_ObjectData2270_DCPS_H_
#define _H_9A7C02A5AC8248611A0BF78E82A847E4_ObjectData2270_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObjectData2270_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObjectData2270_TypeSupportInterface;

            typedef ObjectData2270_TypeSupportInterface * ObjectData2270_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2270_TypeSupportInterface> ObjectData2270_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObjectData2270_TypeSupportInterface> ObjectData2270_TypeSupportInterface_out;


            class ObjectData2270_DataWriter;

            typedef ObjectData2270_DataWriter * ObjectData2270_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2270_DataWriter> ObjectData2270_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObjectData2270_DataWriter> ObjectData2270_DataWriter_out;


            class ObjectData2270_DataReader;

            typedef ObjectData2270_DataReader * ObjectData2270_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2270_DataReader> ObjectData2270_DataReader_var;
            typedef DDS_DCPSInterface_out < ObjectData2270_DataReader> ObjectData2270_DataReader_out;


            class ObjectData2270_DataReaderView;

            typedef ObjectData2270_DataReaderView * ObjectData2270_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2270_DataReaderView> ObjectData2270_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObjectData2270_DataReaderView> ObjectData2270_DataReaderView_out;

            struct ObjectData2270_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObjectData2270_, struct ObjectData2270_Seq_uniq_> ObjectData2270_Seq;
            typedef DDS_DCPSSequence_var < ObjectData2270_Seq> ObjectData2270_Seq_var;
            typedef DDS_DCPSSequence_out < ObjectData2270_Seq> ObjectData2270_Seq_out;

            class  ObjectData2270_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObjectData2270_TypeSupportInterface_ptr _ptr_type;
                typedef ObjectData2270_TypeSupportInterface_var _var_type;

                static ObjectData2270_TypeSupportInterface_ptr _duplicate (ObjectData2270_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2270_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2270_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2270_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2270_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObjectData2270_TypeSupportInterface () {};
                ~ObjectData2270_TypeSupportInterface () {};
            private:
                ObjectData2270_TypeSupportInterface (const ObjectData2270_TypeSupportInterface &);
                ObjectData2270_TypeSupportInterface & operator = (const ObjectData2270_TypeSupportInterface &);
            };

            class  ObjectData2270_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObjectData2270_DataWriter_ptr _ptr_type;
                typedef ObjectData2270_DataWriter_var _var_type;

                static ObjectData2270_DataWriter_ptr _duplicate (ObjectData2270_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2270_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2270_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2270_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2270_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObjectData2270_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObjectData2270_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObjectData2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObjectData2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObjectData2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObjectData2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObjectData2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObjectData2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObjectData2270_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObjectData2270_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObjectData2270_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2270_& instance_data) = 0;

            protected:
                ObjectData2270_DataWriter () {};
                ~ObjectData2270_DataWriter () {};
            private:
                ObjectData2270_DataWriter (const ObjectData2270_DataWriter &);
                ObjectData2270_DataWriter & operator = (const ObjectData2270_DataWriter &);
            };

            class  ObjectData2270_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObjectData2270_DataReader_ptr _ptr_type;
                typedef ObjectData2270_DataReader_var _var_type;

                static ObjectData2270_DataReader_ptr _duplicate (ObjectData2270_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2270_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2270_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2270_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2270_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2270_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2270_& instance) = 0;

            protected:
                ObjectData2270_DataReader () {};
                ~ObjectData2270_DataReader () {};
            private:
                ObjectData2270_DataReader (const ObjectData2270_DataReader &);
                ObjectData2270_DataReader & operator = (const ObjectData2270_DataReader &);
            };

            class  ObjectData2270_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObjectData2270_DataReaderView_ptr _ptr_type;
                typedef ObjectData2270_DataReaderView_var _var_type;

                static ObjectData2270_DataReaderView_ptr _duplicate (ObjectData2270_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2270_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2270_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2270_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2270_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2270_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2270_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2270_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2270_& instance) = 0;

            protected:
                ObjectData2270_DataReaderView () {};
                ~ObjectData2270_DataReaderView () {};
            private:
                ObjectData2270_DataReaderView (const ObjectData2270_DataReaderView &);
                ObjectData2270_DataReaderView & operator = (const ObjectData2270_DataReaderView &);
            };
        }

    }

}

#endif
