#ifndef _H_9E6822625B64BFE5D28E862E09EAE42E_Point2Di_DCPS_H_
#define _H_9E6822625B64BFE5D28E862E09EAE42E_Point2Di_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Point2Di_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Point2Di_TypeSupportInterface;

            typedef Point2Di_TypeSupportInterface * Point2Di_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Point2Di_TypeSupportInterface> Point2Di_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Point2Di_TypeSupportInterface> Point2Di_TypeSupportInterface_out;


            class Point2Di_DataWriter;

            typedef Point2Di_DataWriter * Point2Di_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Point2Di_DataWriter> Point2Di_DataWriter_var;
            typedef DDS_DCPSInterface_out < Point2Di_DataWriter> Point2Di_DataWriter_out;


            class Point2Di_DataReader;

            typedef Point2Di_DataReader * Point2Di_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Point2Di_DataReader> Point2Di_DataReader_var;
            typedef DDS_DCPSInterface_out < Point2Di_DataReader> Point2Di_DataReader_out;


            class Point2Di_DataReaderView;

            typedef Point2Di_DataReaderView * Point2Di_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Point2Di_DataReaderView> Point2Di_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Point2Di_DataReaderView> Point2Di_DataReaderView_out;

            struct Point2Di_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Point2Di_, struct Point2Di_Seq_uniq_> Point2Di_Seq;
            typedef DDS_DCPSSequence_var < Point2Di_Seq> Point2Di_Seq_var;
            typedef DDS_DCPSSequence_out < Point2Di_Seq> Point2Di_Seq_out;

            class  Point2Di_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Point2Di_TypeSupportInterface_ptr _ptr_type;
                typedef Point2Di_TypeSupportInterface_var _var_type;

                static Point2Di_TypeSupportInterface_ptr _duplicate (Point2Di_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Di_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Point2Di_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Di_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Di_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Point2Di_TypeSupportInterface () {};
                ~Point2Di_TypeSupportInterface () {};
            private:
                Point2Di_TypeSupportInterface (const Point2Di_TypeSupportInterface &);
                Point2Di_TypeSupportInterface & operator = (const Point2Di_TypeSupportInterface &);
            };

            class  Point2Di_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Point2Di_DataWriter_ptr _ptr_type;
                typedef Point2Di_DataWriter_var _var_type;

                static Point2Di_DataWriter_ptr _duplicate (Point2Di_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Di_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Point2Di_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Di_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Di_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Point2Di_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Point2Di_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Point2Di_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Point2Di_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Point2Di_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Point2Di_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Point2Di_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Point2Di_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Point2Di_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Point2Di_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Point2Di_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Point2Di_& instance_data) = 0;

            protected:
                Point2Di_DataWriter () {};
                ~Point2Di_DataWriter () {};
            private:
                Point2Di_DataWriter (const Point2Di_DataWriter &);
                Point2Di_DataWriter & operator = (const Point2Di_DataWriter &);
            };

            class  Point2Di_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Point2Di_DataReader_ptr _ptr_type;
                typedef Point2Di_DataReader_var _var_type;

                static Point2Di_DataReader_ptr _duplicate (Point2Di_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Di_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Point2Di_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Di_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Di_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Point2Di_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Point2Di_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Point2Di_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Point2Di_& instance) = 0;

            protected:
                Point2Di_DataReader () {};
                ~Point2Di_DataReader () {};
            private:
                Point2Di_DataReader (const Point2Di_DataReader &);
                Point2Di_DataReader & operator = (const Point2Di_DataReader &);
            };

            class  Point2Di_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Point2Di_DataReaderView_ptr _ptr_type;
                typedef Point2Di_DataReaderView_var _var_type;

                static Point2Di_DataReaderView_ptr _duplicate (Point2Di_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Di_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Point2Di_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Di_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Di_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Point2Di_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Point2Di_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Point2Di_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Point2Di_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Point2Di_& instance) = 0;

            protected:
                Point2Di_DataReaderView () {};
                ~Point2Di_DataReaderView () {};
            private:
                Point2Di_DataReaderView (const Point2Di_DataReaderView &);
                Point2Di_DataReaderView & operator = (const Point2Di_DataReaderView &);
            };
        }

    }

}

#endif
