#ifndef _H_9EF2B073A19CE3D5F1E313DBE70FC5D3_ResolutionInfo_DCPS_H_
#define _H_9EF2B073A19CE3D5F1E313DBE70FC5D3_ResolutionInfo_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ResolutionInfo_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ResolutionInfo_TypeSupportInterface;

            typedef ResolutionInfo_TypeSupportInterface * ResolutionInfo_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ResolutionInfo_TypeSupportInterface> ResolutionInfo_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ResolutionInfo_TypeSupportInterface> ResolutionInfo_TypeSupportInterface_out;


            class ResolutionInfo_DataWriter;

            typedef ResolutionInfo_DataWriter * ResolutionInfo_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ResolutionInfo_DataWriter> ResolutionInfo_DataWriter_var;
            typedef DDS_DCPSInterface_out < ResolutionInfo_DataWriter> ResolutionInfo_DataWriter_out;


            class ResolutionInfo_DataReader;

            typedef ResolutionInfo_DataReader * ResolutionInfo_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ResolutionInfo_DataReader> ResolutionInfo_DataReader_var;
            typedef DDS_DCPSInterface_out < ResolutionInfo_DataReader> ResolutionInfo_DataReader_out;


            class ResolutionInfo_DataReaderView;

            typedef ResolutionInfo_DataReaderView * ResolutionInfo_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ResolutionInfo_DataReaderView> ResolutionInfo_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ResolutionInfo_DataReaderView> ResolutionInfo_DataReaderView_out;

            struct ResolutionInfo_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ResolutionInfo_, struct ResolutionInfo_Seq_uniq_> ResolutionInfo_Seq;
            typedef DDS_DCPSSequence_var < ResolutionInfo_Seq> ResolutionInfo_Seq_var;
            typedef DDS_DCPSSequence_out < ResolutionInfo_Seq> ResolutionInfo_Seq_out;

            class  ResolutionInfo_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ResolutionInfo_TypeSupportInterface_ptr _ptr_type;
                typedef ResolutionInfo_TypeSupportInterface_var _var_type;

                static ResolutionInfo_TypeSupportInterface_ptr _duplicate (ResolutionInfo_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ResolutionInfo_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ResolutionInfo_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ResolutionInfo_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ResolutionInfo_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ResolutionInfo_TypeSupportInterface () {};
                ~ResolutionInfo_TypeSupportInterface () {};
            private:
                ResolutionInfo_TypeSupportInterface (const ResolutionInfo_TypeSupportInterface &);
                ResolutionInfo_TypeSupportInterface & operator = (const ResolutionInfo_TypeSupportInterface &);
            };

            class  ResolutionInfo_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ResolutionInfo_DataWriter_ptr _ptr_type;
                typedef ResolutionInfo_DataWriter_var _var_type;

                static ResolutionInfo_DataWriter_ptr _duplicate (ResolutionInfo_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ResolutionInfo_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ResolutionInfo_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ResolutionInfo_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ResolutionInfo_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ResolutionInfo_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ResolutionInfo_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ResolutionInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ResolutionInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ResolutionInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ResolutionInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ResolutionInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ResolutionInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ResolutionInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ResolutionInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ResolutionInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ResolutionInfo_& instance_data) = 0;

            protected:
                ResolutionInfo_DataWriter () {};
                ~ResolutionInfo_DataWriter () {};
            private:
                ResolutionInfo_DataWriter (const ResolutionInfo_DataWriter &);
                ResolutionInfo_DataWriter & operator = (const ResolutionInfo_DataWriter &);
            };

            class  ResolutionInfo_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ResolutionInfo_DataReader_ptr _ptr_type;
                typedef ResolutionInfo_DataReader_var _var_type;

                static ResolutionInfo_DataReader_ptr _duplicate (ResolutionInfo_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ResolutionInfo_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ResolutionInfo_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ResolutionInfo_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ResolutionInfo_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ResolutionInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ResolutionInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ResolutionInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ResolutionInfo_& instance) = 0;

            protected:
                ResolutionInfo_DataReader () {};
                ~ResolutionInfo_DataReader () {};
            private:
                ResolutionInfo_DataReader (const ResolutionInfo_DataReader &);
                ResolutionInfo_DataReader & operator = (const ResolutionInfo_DataReader &);
            };

            class  ResolutionInfo_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ResolutionInfo_DataReaderView_ptr _ptr_type;
                typedef ResolutionInfo_DataReaderView_var _var_type;

                static ResolutionInfo_DataReaderView_ptr _duplicate (ResolutionInfo_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ResolutionInfo_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ResolutionInfo_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ResolutionInfo_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ResolutionInfo_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ResolutionInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ResolutionInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ResolutionInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ResolutionInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ResolutionInfo_& instance) = 0;

            protected:
                ResolutionInfo_DataReaderView () {};
                ~ResolutionInfo_DataReaderView () {};
            private:
                ResolutionInfo_DataReaderView (const ResolutionInfo_DataReaderView &);
                ResolutionInfo_DataReaderView & operator = (const ResolutionInfo_DataReaderView &);
            };
        }

    }

}

#endif
