#ifndef _H_477F7E208F0722ACE712336EBC1C9A95_ScanData2202__H_
#define _H_477F7E208F0722ACE712336EBC1C9A95_ScanData2202__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "ibeo_msgs/msg/dds_opensplice/ScanPoint2202_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ScanData2202_Constants
            {
                const ::DDS::Octet FRONT_ = 0;

                const ::DDS::Octet REAR_ = 1;

            }

            struct  ScanData2202_
            {
                struct _scan_point_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::ScanPoint2202_, struct _scan_point_list__seq_uniq_ > _scan_point_list__seq;
                typedef DDS_DCPSSequence_var< _scan_point_list__seq > _scan_point_list__seq_var;
                typedef DDS_DCPSSequence_out< _scan_point_list__seq > _scan_point_list__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::DDS::UShort scan_number_;
                ::DDS::UShort scanner_status_;
                ::DDS::UShort sync_phase_offset_;
                ::builtin_interfaces::msg::dds_::Time_ scan_start_time_;
                ::builtin_interfaces::msg::dds_::Time_ scan_end_time_;
                ::DDS::UShort angle_ticks_per_rotation_;
                ::DDS::Short start_angle_ticks_;
                ::DDS::Short end_angle_ticks_;
                ::DDS::UShort scan_points_count_;
                ::DDS::Short mounting_yaw_angle_ticks_;
                ::DDS::Short mounting_pitch_angle_ticks_;
                ::DDS::Short mounting_roll_angle_ticks_;
                ::DDS::Short mounting_position_x_;
                ::DDS::Short mounting_position_y_;
                ::DDS::Short mounting_position_z_;
                ::DDS::Boolean ground_labeled_;
                ::DDS::Boolean dirt_labeled_;
                ::DDS::Boolean rain_labeled_;
                ::DDS::Octet mirror_side_;
                _scan_point_list__seq scan_point_list_;
            };

            typedef DDS_DCPSStruct_var<ScanData2202_> ScanData2202__var;
            typedef DDS_DCPSStruct_out < ScanData2202_> ScanData2202__out;

        }

    }

}

#endif /* _H_477F7E208F0722ACE712336EBC1C9A95_ScanData2202__H_ */
