#ifndef _H_3E9E74F479D39DAFC7CC6E19FAFA960E_ScanData2208__H_
#define _H_3E9E74F479D39DAFC7CC6E19FAFA960E_ScanData2208__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "ibeo_msgs/msg/dds_opensplice/ScanPoint2208_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ScanData2208_Constants
            {
                const ::DDS::UShort SCALA_B2_ = 11520U;

                const ::DDS::Octet CLOCKWISE_ = 0;

                const ::DDS::Octet COUNTER_CLOCKWISE_ = 1;

                const ::DDS::Octet FRONT_MIRROR_ = 0;

                const ::DDS::Octet REAR_MIRROR_ = 1;

            }

            struct  ScanData2208_
            {
                struct _scan_point_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::ScanPoint2208_, struct _scan_point_list__seq_uniq_ > _scan_point_list__seq;
                typedef DDS_DCPSSequence_var< _scan_point_list__seq > _scan_point_list__seq_var;
                typedef DDS_DCPSSequence_out< _scan_point_list__seq > _scan_point_list__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::DDS::UShort scan_number_;
                ::DDS::UShort scanner_type_;
                ::DDS::Boolean motor_on_;
                ::DDS::Boolean laser_on_;
                ::DDS::Boolean frequency_locked_;
                ::DDS::Octet motor_rotating_direction_;
                ::DDS::UShort angle_ticks_per_rotation_;
                ::DDS::ULong scan_flags_;
                ::DDS::Short mounting_yaw_angle_ticks_;
                ::DDS::Short mounting_pitch_angle_ticks_;
                ::DDS::Short mounting_roll_angle_ticks_;
                ::DDS::Short mounting_position_x_;
                ::DDS::Short mounting_position_y_;
                ::DDS::Short mounting_position_z_;
                ::DDS::Octet device_id_;
                ::builtin_interfaces::msg::dds_::Time_ scan_start_time_;
                ::builtin_interfaces::msg::dds_::Time_ scan_end_time_;
                ::DDS::Short start_angle_ticks_;
                ::DDS::Short end_angle_ticks_;
                ::DDS::Octet mirror_side_;
                ::DDS::Short mirror_tilt_;
                _scan_point_list__seq scan_point_list_;
            };

            typedef DDS_DCPSStruct_var<ScanData2208_> ScanData2208__var;
            typedef DDS_DCPSStruct_out < ScanData2208_> ScanData2208__out;

        }

    }

}

#endif /* _H_3E9E74F479D39DAFC7CC6E19FAFA960E_ScanData2208__H_ */
