#ifndef _H_3E9E74F479D39DAFC7CC6E19FAFA960E_ScanData2208_DCPS_H_
#define _H_3E9E74F479D39DAFC7CC6E19FAFA960E_ScanData2208_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScanData2208_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScanData2208_TypeSupportInterface;

            typedef ScanData2208_TypeSupportInterface * ScanData2208_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScanData2208_TypeSupportInterface> ScanData2208_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScanData2208_TypeSupportInterface> ScanData2208_TypeSupportInterface_out;


            class ScanData2208_DataWriter;

            typedef ScanData2208_DataWriter * ScanData2208_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScanData2208_DataWriter> ScanData2208_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScanData2208_DataWriter> ScanData2208_DataWriter_out;


            class ScanData2208_DataReader;

            typedef ScanData2208_DataReader * ScanData2208_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScanData2208_DataReader> ScanData2208_DataReader_var;
            typedef DDS_DCPSInterface_out < ScanData2208_DataReader> ScanData2208_DataReader_out;


            class ScanData2208_DataReaderView;

            typedef ScanData2208_DataReaderView * ScanData2208_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScanData2208_DataReaderView> ScanData2208_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScanData2208_DataReaderView> ScanData2208_DataReaderView_out;

            struct ScanData2208_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ScanData2208_, struct ScanData2208_Seq_uniq_> ScanData2208_Seq;
            typedef DDS_DCPSSequence_var < ScanData2208_Seq> ScanData2208_Seq_var;
            typedef DDS_DCPSSequence_out < ScanData2208_Seq> ScanData2208_Seq_out;

            class  ScanData2208_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScanData2208_TypeSupportInterface_ptr _ptr_type;
                typedef ScanData2208_TypeSupportInterface_var _var_type;

                static ScanData2208_TypeSupportInterface_ptr _duplicate (ScanData2208_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2208_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2208_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2208_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2208_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScanData2208_TypeSupportInterface () {};
                ~ScanData2208_TypeSupportInterface () {};
            private:
                ScanData2208_TypeSupportInterface (const ScanData2208_TypeSupportInterface &);
                ScanData2208_TypeSupportInterface & operator = (const ScanData2208_TypeSupportInterface &);
            };

            class  ScanData2208_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScanData2208_DataWriter_ptr _ptr_type;
                typedef ScanData2208_DataWriter_var _var_type;

                static ScanData2208_DataWriter_ptr _duplicate (ScanData2208_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2208_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2208_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2208_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2208_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScanData2208_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScanData2208_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScanData2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScanData2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScanData2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScanData2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScanData2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScanData2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScanData2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScanData2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScanData2208_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2208_& instance_data) = 0;

            protected:
                ScanData2208_DataWriter () {};
                ~ScanData2208_DataWriter () {};
            private:
                ScanData2208_DataWriter (const ScanData2208_DataWriter &);
                ScanData2208_DataWriter & operator = (const ScanData2208_DataWriter &);
            };

            class  ScanData2208_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScanData2208_DataReader_ptr _ptr_type;
                typedef ScanData2208_DataReader_var _var_type;

                static ScanData2208_DataReader_ptr _duplicate (ScanData2208_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2208_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2208_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2208_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2208_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2208_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2208_& instance) = 0;

            protected:
                ScanData2208_DataReader () {};
                ~ScanData2208_DataReader () {};
            private:
                ScanData2208_DataReader (const ScanData2208_DataReader &);
                ScanData2208_DataReader & operator = (const ScanData2208_DataReader &);
            };

            class  ScanData2208_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScanData2208_DataReaderView_ptr _ptr_type;
                typedef ScanData2208_DataReaderView_var _var_type;

                static ScanData2208_DataReaderView_ptr _duplicate (ScanData2208_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2208_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2208_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2208_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2208_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2208_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2208_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2208_& instance) = 0;

            protected:
                ScanData2208_DataReaderView () {};
                ~ScanData2208_DataReaderView () {};
            private:
                ScanData2208_DataReaderView (const ScanData2208_DataReaderView &);
                ScanData2208_DataReaderView & operator = (const ScanData2208_DataReaderView &);
            };
        }

    }

}

#endif
