#ifndef _H_4CB135DCF4D8E864EFA5C85C0C54499F_ScanPoint2208_DCPS_H_
#define _H_4CB135DCF4D8E864EFA5C85C0C54499F_ScanPoint2208_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScanPoint2208_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScanPoint2208_TypeSupportInterface;

            typedef ScanPoint2208_TypeSupportInterface * ScanPoint2208_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2208_TypeSupportInterface> ScanPoint2208_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScanPoint2208_TypeSupportInterface> ScanPoint2208_TypeSupportInterface_out;


            class ScanPoint2208_DataWriter;

            typedef ScanPoint2208_DataWriter * ScanPoint2208_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2208_DataWriter> ScanPoint2208_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScanPoint2208_DataWriter> ScanPoint2208_DataWriter_out;


            class ScanPoint2208_DataReader;

            typedef ScanPoint2208_DataReader * ScanPoint2208_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2208_DataReader> ScanPoint2208_DataReader_var;
            typedef DDS_DCPSInterface_out < ScanPoint2208_DataReader> ScanPoint2208_DataReader_out;


            class ScanPoint2208_DataReaderView;

            typedef ScanPoint2208_DataReaderView * ScanPoint2208_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2208_DataReaderView> ScanPoint2208_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScanPoint2208_DataReaderView> ScanPoint2208_DataReaderView_out;

            struct ScanPoint2208_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ScanPoint2208_, struct ScanPoint2208_Seq_uniq_> ScanPoint2208_Seq;
            typedef DDS_DCPSSequence_var < ScanPoint2208_Seq> ScanPoint2208_Seq_var;
            typedef DDS_DCPSSequence_out < ScanPoint2208_Seq> ScanPoint2208_Seq_out;

            class  ScanPoint2208_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScanPoint2208_TypeSupportInterface_ptr _ptr_type;
                typedef ScanPoint2208_TypeSupportInterface_var _var_type;

                static ScanPoint2208_TypeSupportInterface_ptr _duplicate (ScanPoint2208_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2208_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2208_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2208_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2208_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScanPoint2208_TypeSupportInterface () {};
                ~ScanPoint2208_TypeSupportInterface () {};
            private:
                ScanPoint2208_TypeSupportInterface (const ScanPoint2208_TypeSupportInterface &);
                ScanPoint2208_TypeSupportInterface & operator = (const ScanPoint2208_TypeSupportInterface &);
            };

            class  ScanPoint2208_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScanPoint2208_DataWriter_ptr _ptr_type;
                typedef ScanPoint2208_DataWriter_var _var_type;

                static ScanPoint2208_DataWriter_ptr _duplicate (ScanPoint2208_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2208_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2208_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2208_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2208_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScanPoint2208_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScanPoint2208_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScanPoint2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScanPoint2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScanPoint2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScanPoint2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScanPoint2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScanPoint2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScanPoint2208_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScanPoint2208_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScanPoint2208_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanPoint2208_& instance_data) = 0;

            protected:
                ScanPoint2208_DataWriter () {};
                ~ScanPoint2208_DataWriter () {};
            private:
                ScanPoint2208_DataWriter (const ScanPoint2208_DataWriter &);
                ScanPoint2208_DataWriter & operator = (const ScanPoint2208_DataWriter &);
            };

            class  ScanPoint2208_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScanPoint2208_DataReader_ptr _ptr_type;
                typedef ScanPoint2208_DataReader_var _var_type;

                static ScanPoint2208_DataReader_ptr _duplicate (ScanPoint2208_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2208_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2208_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2208_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2208_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanPoint2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanPoint2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanPoint2208_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanPoint2208_& instance) = 0;

            protected:
                ScanPoint2208_DataReader () {};
                ~ScanPoint2208_DataReader () {};
            private:
                ScanPoint2208_DataReader (const ScanPoint2208_DataReader &);
                ScanPoint2208_DataReader & operator = (const ScanPoint2208_DataReader &);
            };

            class  ScanPoint2208_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScanPoint2208_DataReaderView_ptr _ptr_type;
                typedef ScanPoint2208_DataReaderView_var _var_type;

                static ScanPoint2208_DataReaderView_ptr _duplicate (ScanPoint2208_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2208_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2208_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2208_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2208_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanPoint2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanPoint2208_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanPoint2208_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanPoint2208_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanPoint2208_& instance) = 0;

            protected:
                ScanPoint2208_DataReaderView () {};
                ~ScanPoint2208_DataReaderView () {};
            private:
                ScanPoint2208_DataReaderView (const ScanPoint2208_DataReaderView &);
                ScanPoint2208_DataReaderView & operator = (const ScanPoint2208_DataReaderView &);
            };
        }

    }

}

#endif
