#ifndef _H_3E38E404BFFB96574E519EE688FA1B4C_ScannerInfo2204__H_
#define _H_3E38E404BFFB96574E519EE688FA1B4C_ScannerInfo2204__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ScannerInfo2204_Constants
            {
                const ::DDS::Octet ALASCA_XT_ = 3;

                const ::DDS::Octet LUX_ECU_ = 4;

                const ::DDS::Octet LUX_PROTOTYPE_ = 5;

                const ::DDS::Octet LUX_ = 6;

                const ::DDS::Octet SCALA_B1_ = 96;

            }

            struct  ScannerInfo2204_
            {
                ::DDS::Octet device_id_;
                ::DDS::Octet scanner_type_;
                ::DDS::UShort scan_number_;
                ::DDS::Float start_angle_;
                ::DDS::Float end_angle_;
                ::DDS::Float yaw_angle_;
                ::DDS::Float pitch_angle_;
                ::DDS::Float roll_angle_;
                ::DDS::Float offset_x_;
                ::DDS::Float offset_y_;
                ::DDS::Float offset_z_;
            };

            typedef DDS_DCPSStruct_var<ScannerInfo2204_> ScannerInfo2204__var;
            typedef ScannerInfo2204_& ScannerInfo2204__out;

        }

    }

}

#endif /* _H_3E38E404BFFB96574E519EE688FA1B4C_ScannerInfo2204__H_ */
