#ifndef _H_3E38E404BFFB96574E519EE688FA1B4C_ScannerInfo2204_DCPS_H_
#define _H_3E38E404BFFB96574E519EE688FA1B4C_ScannerInfo2204_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScannerInfo2204_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScannerInfo2204_TypeSupportInterface;

            typedef ScannerInfo2204_TypeSupportInterface * ScannerInfo2204_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2204_TypeSupportInterface> ScannerInfo2204_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2204_TypeSupportInterface> ScannerInfo2204_TypeSupportInterface_out;


            class ScannerInfo2204_DataWriter;

            typedef ScannerInfo2204_DataWriter * ScannerInfo2204_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2204_DataWriter> ScannerInfo2204_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2204_DataWriter> ScannerInfo2204_DataWriter_out;


            class ScannerInfo2204_DataReader;

            typedef ScannerInfo2204_DataReader * ScannerInfo2204_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2204_DataReader> ScannerInfo2204_DataReader_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2204_DataReader> ScannerInfo2204_DataReader_out;


            class ScannerInfo2204_DataReaderView;

            typedef ScannerInfo2204_DataReaderView * ScannerInfo2204_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2204_DataReaderView> ScannerInfo2204_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2204_DataReaderView> ScannerInfo2204_DataReaderView_out;

            struct ScannerInfo2204_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ScannerInfo2204_, struct ScannerInfo2204_Seq_uniq_> ScannerInfo2204_Seq;
            typedef DDS_DCPSSequence_var < ScannerInfo2204_Seq> ScannerInfo2204_Seq_var;
            typedef DDS_DCPSSequence_out < ScannerInfo2204_Seq> ScannerInfo2204_Seq_out;

            class  ScannerInfo2204_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScannerInfo2204_TypeSupportInterface_ptr _ptr_type;
                typedef ScannerInfo2204_TypeSupportInterface_var _var_type;

                static ScannerInfo2204_TypeSupportInterface_ptr _duplicate (ScannerInfo2204_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2204_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2204_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScannerInfo2204_TypeSupportInterface () {};
                ~ScannerInfo2204_TypeSupportInterface () {};
            private:
                ScannerInfo2204_TypeSupportInterface (const ScannerInfo2204_TypeSupportInterface &);
                ScannerInfo2204_TypeSupportInterface & operator = (const ScannerInfo2204_TypeSupportInterface &);
            };

            class  ScannerInfo2204_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScannerInfo2204_DataWriter_ptr _ptr_type;
                typedef ScannerInfo2204_DataWriter_var _var_type;

                static ScannerInfo2204_DataWriter_ptr _duplicate (ScannerInfo2204_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2204_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2204_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScannerInfo2204_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScannerInfo2204_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScannerInfo2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScannerInfo2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScannerInfo2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScannerInfo2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScannerInfo2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScannerInfo2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScannerInfo2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScannerInfo2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScannerInfo2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScannerInfo2204_& instance_data) = 0;

            protected:
                ScannerInfo2204_DataWriter () {};
                ~ScannerInfo2204_DataWriter () {};
            private:
                ScannerInfo2204_DataWriter (const ScannerInfo2204_DataWriter &);
                ScannerInfo2204_DataWriter & operator = (const ScannerInfo2204_DataWriter &);
            };

            class  ScannerInfo2204_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScannerInfo2204_DataReader_ptr _ptr_type;
                typedef ScannerInfo2204_DataReader_var _var_type;

                static ScannerInfo2204_DataReader_ptr _duplicate (ScannerInfo2204_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2204_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2204_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScannerInfo2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScannerInfo2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScannerInfo2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScannerInfo2204_& instance) = 0;

            protected:
                ScannerInfo2204_DataReader () {};
                ~ScannerInfo2204_DataReader () {};
            private:
                ScannerInfo2204_DataReader (const ScannerInfo2204_DataReader &);
                ScannerInfo2204_DataReader & operator = (const ScannerInfo2204_DataReader &);
            };

            class  ScannerInfo2204_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScannerInfo2204_DataReaderView_ptr _ptr_type;
                typedef ScannerInfo2204_DataReaderView_var _var_type;

                static ScannerInfo2204_DataReaderView_ptr _duplicate (ScannerInfo2204_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2204_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2204_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2204_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScannerInfo2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScannerInfo2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScannerInfo2204_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScannerInfo2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScannerInfo2204_& instance) = 0;

            protected:
                ScannerInfo2204_DataReaderView () {};
                ~ScannerInfo2204_DataReaderView () {};
            private:
                ScannerInfo2204_DataReaderView (const ScannerInfo2204_DataReaderView &);
                ScannerInfo2204_DataReaderView & operator = (const ScannerInfo2204_DataReaderView &);
            };
        }

    }

}

#endif
