#ifndef _H_D3C27647F383A36E1299DD652E1BCFF7_ScannerInfo2205__H_
#define _H_D3C27647F383A36E1299DD652E1BCFF7_ScannerInfo2205__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "ibeo_msgs/msg/dds_opensplice/MountingPositionF_.h"
#include "ibeo_msgs/msg/dds_opensplice/ResolutionInfo_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ScannerInfo2205_Constants
            {
                const ::DDS::Octet ALASCA_XT_ = 3;

                const ::DDS::Octet LUX_ECU_ = 4;

                const ::DDS::Octet LUX_PROTOTYPE_ = 5;

                const ::DDS::Octet LUX_ = 6;

                const ::DDS::Octet SCALA_B1_ = 96;

            }

            struct  ScannerInfo2205_
            {
                struct _resolutions__uniq_{};
                typedef ::ibeo_msgs::msg::dds_::ResolutionInfo_ _resolutions__slice;
                typedef ::ibeo_msgs::msg::dds_::ResolutionInfo_ _resolutions_[8];
                typedef DDS_DCPS_FArray_var< _resolutions_, _resolutions__slice, struct _resolutions__uniq_ > _resolutions__var;
                typedef _resolutions_ _resolutions__out;
                typedef DDS_DCPS_Array_forany< _resolutions_, _resolutions__slice, struct _resolutions__uniq_ > _resolutions__forany;
                static _resolutions__slice *_resolutions__alloc();
                static void _resolutions__free(_resolutions__slice *);
                static void _resolutions__copy(_resolutions__slice *to, const _resolutions__slice *from);
                static _resolutions__slice *_resolutions__dup(const _resolutions__slice *from);
                ::DDS::Octet device_id_;
                ::DDS::Octet scanner_type_;
                ::DDS::UShort scan_number_;
                ::DDS::Float start_angle_;
                ::DDS::Float end_angle_;
                ::builtin_interfaces::msg::dds_::Time_ scan_start_time_;
                ::builtin_interfaces::msg::dds_::Time_ scan_end_time_;
                ::builtin_interfaces::msg::dds_::Time_ scan_start_time_from_device_;
                ::builtin_interfaces::msg::dds_::Time_ scan_end_time_from_device_;
                ::DDS::Float scan_frequency_;
                ::DDS::Float beam_tilt_;
                ::DDS::ULong scan_flags_;
                ::ibeo_msgs::msg::dds_::MountingPositionF_ mounting_position_;
                _resolutions_ resolutions_;
            };

            typedef DDS_DCPSStruct_var<ScannerInfo2205_> ScannerInfo2205__var;
            typedef ScannerInfo2205_& ScannerInfo2205__out;

        }

    }

}

#endif /* _H_D3C27647F383A36E1299DD652E1BCFF7_ScannerInfo2205__H_ */
