#ifndef _H_D3C27647F383A36E1299DD652E1BCFF7_ScannerInfo2205_DCPS_H_
#define _H_D3C27647F383A36E1299DD652E1BCFF7_ScannerInfo2205_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScannerInfo2205_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScannerInfo2205_TypeSupportInterface;

            typedef ScannerInfo2205_TypeSupportInterface * ScannerInfo2205_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2205_TypeSupportInterface> ScannerInfo2205_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2205_TypeSupportInterface> ScannerInfo2205_TypeSupportInterface_out;


            class ScannerInfo2205_DataWriter;

            typedef ScannerInfo2205_DataWriter * ScannerInfo2205_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2205_DataWriter> ScannerInfo2205_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2205_DataWriter> ScannerInfo2205_DataWriter_out;


            class ScannerInfo2205_DataReader;

            typedef ScannerInfo2205_DataReader * ScannerInfo2205_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2205_DataReader> ScannerInfo2205_DataReader_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2205_DataReader> ScannerInfo2205_DataReader_out;


            class ScannerInfo2205_DataReaderView;

            typedef ScannerInfo2205_DataReaderView * ScannerInfo2205_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScannerInfo2205_DataReaderView> ScannerInfo2205_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScannerInfo2205_DataReaderView> ScannerInfo2205_DataReaderView_out;

            struct ScannerInfo2205_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ScannerInfo2205_, struct ScannerInfo2205_Seq_uniq_> ScannerInfo2205_Seq;
            typedef DDS_DCPSSequence_var < ScannerInfo2205_Seq> ScannerInfo2205_Seq_var;
            typedef DDS_DCPSSequence_out < ScannerInfo2205_Seq> ScannerInfo2205_Seq_out;

            class  ScannerInfo2205_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScannerInfo2205_TypeSupportInterface_ptr _ptr_type;
                typedef ScannerInfo2205_TypeSupportInterface_var _var_type;

                static ScannerInfo2205_TypeSupportInterface_ptr _duplicate (ScannerInfo2205_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2205_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2205_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScannerInfo2205_TypeSupportInterface () {};
                ~ScannerInfo2205_TypeSupportInterface () {};
            private:
                ScannerInfo2205_TypeSupportInterface (const ScannerInfo2205_TypeSupportInterface &);
                ScannerInfo2205_TypeSupportInterface & operator = (const ScannerInfo2205_TypeSupportInterface &);
            };

            class  ScannerInfo2205_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScannerInfo2205_DataWriter_ptr _ptr_type;
                typedef ScannerInfo2205_DataWriter_var _var_type;

                static ScannerInfo2205_DataWriter_ptr _duplicate (ScannerInfo2205_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2205_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2205_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScannerInfo2205_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScannerInfo2205_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScannerInfo2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScannerInfo2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScannerInfo2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScannerInfo2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScannerInfo2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScannerInfo2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScannerInfo2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScannerInfo2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScannerInfo2205_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScannerInfo2205_& instance_data) = 0;

            protected:
                ScannerInfo2205_DataWriter () {};
                ~ScannerInfo2205_DataWriter () {};
            private:
                ScannerInfo2205_DataWriter (const ScannerInfo2205_DataWriter &);
                ScannerInfo2205_DataWriter & operator = (const ScannerInfo2205_DataWriter &);
            };

            class  ScannerInfo2205_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScannerInfo2205_DataReader_ptr _ptr_type;
                typedef ScannerInfo2205_DataReader_var _var_type;

                static ScannerInfo2205_DataReader_ptr _duplicate (ScannerInfo2205_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2205_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2205_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScannerInfo2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScannerInfo2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScannerInfo2205_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScannerInfo2205_& instance) = 0;

            protected:
                ScannerInfo2205_DataReader () {};
                ~ScannerInfo2205_DataReader () {};
            private:
                ScannerInfo2205_DataReader (const ScannerInfo2205_DataReader &);
                ScannerInfo2205_DataReader & operator = (const ScannerInfo2205_DataReader &);
            };

            class  ScannerInfo2205_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScannerInfo2205_DataReaderView_ptr _ptr_type;
                typedef ScannerInfo2205_DataReaderView_var _var_type;

                static ScannerInfo2205_DataReaderView_ptr _duplicate (ScannerInfo2205_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScannerInfo2205_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScannerInfo2205_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScannerInfo2205_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScannerInfo2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScannerInfo2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScannerInfo2205_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScannerInfo2205_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScannerInfo2205_& instance) = 0;

            protected:
                ScannerInfo2205_DataReaderView () {};
                ~ScannerInfo2205_DataReaderView () {};
            private:
                ScannerInfo2205_DataReaderView (const ScannerInfo2205_DataReaderView &);
                ScannerInfo2205_DataReaderView & operator = (const ScannerInfo2205_DataReaderView &);
            };
        }

    }

}

#endif
