#ifndef _H_7100A8CDFC72FE1C21336B09E3103DF3_UntrackedProperties_DCPS_H_
#define _H_7100A8CDFC72FE1C21336B09E3103DF3_UntrackedProperties_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UntrackedProperties_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UntrackedProperties_TypeSupportInterface;

            typedef UntrackedProperties_TypeSupportInterface * UntrackedProperties_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UntrackedProperties_TypeSupportInterface> UntrackedProperties_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UntrackedProperties_TypeSupportInterface> UntrackedProperties_TypeSupportInterface_out;


            class UntrackedProperties_DataWriter;

            typedef UntrackedProperties_DataWriter * UntrackedProperties_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UntrackedProperties_DataWriter> UntrackedProperties_DataWriter_var;
            typedef DDS_DCPSInterface_out < UntrackedProperties_DataWriter> UntrackedProperties_DataWriter_out;


            class UntrackedProperties_DataReader;

            typedef UntrackedProperties_DataReader * UntrackedProperties_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UntrackedProperties_DataReader> UntrackedProperties_DataReader_var;
            typedef DDS_DCPSInterface_out < UntrackedProperties_DataReader> UntrackedProperties_DataReader_out;


            class UntrackedProperties_DataReaderView;

            typedef UntrackedProperties_DataReaderView * UntrackedProperties_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UntrackedProperties_DataReaderView> UntrackedProperties_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UntrackedProperties_DataReaderView> UntrackedProperties_DataReaderView_out;

            struct UntrackedProperties_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UntrackedProperties_, struct UntrackedProperties_Seq_uniq_> UntrackedProperties_Seq;
            typedef DDS_DCPSSequence_var < UntrackedProperties_Seq> UntrackedProperties_Seq_var;
            typedef DDS_DCPSSequence_out < UntrackedProperties_Seq> UntrackedProperties_Seq_out;

            class  UntrackedProperties_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UntrackedProperties_TypeSupportInterface_ptr _ptr_type;
                typedef UntrackedProperties_TypeSupportInterface_var _var_type;

                static UntrackedProperties_TypeSupportInterface_ptr _duplicate (UntrackedProperties_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UntrackedProperties_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UntrackedProperties_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UntrackedProperties_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UntrackedProperties_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UntrackedProperties_TypeSupportInterface () {};
                ~UntrackedProperties_TypeSupportInterface () {};
            private:
                UntrackedProperties_TypeSupportInterface (const UntrackedProperties_TypeSupportInterface &);
                UntrackedProperties_TypeSupportInterface & operator = (const UntrackedProperties_TypeSupportInterface &);
            };

            class  UntrackedProperties_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UntrackedProperties_DataWriter_ptr _ptr_type;
                typedef UntrackedProperties_DataWriter_var _var_type;

                static UntrackedProperties_DataWriter_ptr _duplicate (UntrackedProperties_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UntrackedProperties_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UntrackedProperties_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UntrackedProperties_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UntrackedProperties_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UntrackedProperties_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UntrackedProperties_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UntrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UntrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UntrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UntrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UntrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UntrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UntrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UntrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UntrackedProperties_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UntrackedProperties_& instance_data) = 0;

            protected:
                UntrackedProperties_DataWriter () {};
                ~UntrackedProperties_DataWriter () {};
            private:
                UntrackedProperties_DataWriter (const UntrackedProperties_DataWriter &);
                UntrackedProperties_DataWriter & operator = (const UntrackedProperties_DataWriter &);
            };

            class  UntrackedProperties_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UntrackedProperties_DataReader_ptr _ptr_type;
                typedef UntrackedProperties_DataReader_var _var_type;

                static UntrackedProperties_DataReader_ptr _duplicate (UntrackedProperties_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UntrackedProperties_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UntrackedProperties_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UntrackedProperties_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UntrackedProperties_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UntrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UntrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UntrackedProperties_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UntrackedProperties_& instance) = 0;

            protected:
                UntrackedProperties_DataReader () {};
                ~UntrackedProperties_DataReader () {};
            private:
                UntrackedProperties_DataReader (const UntrackedProperties_DataReader &);
                UntrackedProperties_DataReader & operator = (const UntrackedProperties_DataReader &);
            };

            class  UntrackedProperties_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UntrackedProperties_DataReaderView_ptr _ptr_type;
                typedef UntrackedProperties_DataReaderView_var _var_type;

                static UntrackedProperties_DataReaderView_ptr _duplicate (UntrackedProperties_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UntrackedProperties_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UntrackedProperties_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UntrackedProperties_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UntrackedProperties_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UntrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UntrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UntrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UntrackedProperties_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UntrackedProperties_& instance) = 0;

            protected:
                UntrackedProperties_DataReaderView () {};
                ~UntrackedProperties_DataReaderView () {};
            private:
                UntrackedProperties_DataReaderView (const UntrackedProperties_DataReaderView &);
                UntrackedProperties_DataReaderView & operator = (const UntrackedProperties_DataReaderView &);
            };
        }

    }

}

#endif
