#ifndef _H_312257E17612BC724C5B2781E4A5B960_Velocity2D_DCPS_H_
#define _H_312257E17612BC724C5B2781E4A5B960_Velocity2D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Velocity2D_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Velocity2D_TypeSupportInterface;

            typedef Velocity2D_TypeSupportInterface * Velocity2D_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Velocity2D_TypeSupportInterface> Velocity2D_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Velocity2D_TypeSupportInterface> Velocity2D_TypeSupportInterface_out;


            class Velocity2D_DataWriter;

            typedef Velocity2D_DataWriter * Velocity2D_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Velocity2D_DataWriter> Velocity2D_DataWriter_var;
            typedef DDS_DCPSInterface_out < Velocity2D_DataWriter> Velocity2D_DataWriter_out;


            class Velocity2D_DataReader;

            typedef Velocity2D_DataReader * Velocity2D_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Velocity2D_DataReader> Velocity2D_DataReader_var;
            typedef DDS_DCPSInterface_out < Velocity2D_DataReader> Velocity2D_DataReader_out;


            class Velocity2D_DataReaderView;

            typedef Velocity2D_DataReaderView * Velocity2D_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Velocity2D_DataReaderView> Velocity2D_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Velocity2D_DataReaderView> Velocity2D_DataReaderView_out;

            struct Velocity2D_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Velocity2D_, struct Velocity2D_Seq_uniq_> Velocity2D_Seq;
            typedef DDS_DCPSSequence_var < Velocity2D_Seq> Velocity2D_Seq_var;
            typedef DDS_DCPSSequence_out < Velocity2D_Seq> Velocity2D_Seq_out;

            class  Velocity2D_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Velocity2D_TypeSupportInterface_ptr _ptr_type;
                typedef Velocity2D_TypeSupportInterface_var _var_type;

                static Velocity2D_TypeSupportInterface_ptr _duplicate (Velocity2D_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Velocity2D_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Velocity2D_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Velocity2D_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Velocity2D_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Velocity2D_TypeSupportInterface () {};
                ~Velocity2D_TypeSupportInterface () {};
            private:
                Velocity2D_TypeSupportInterface (const Velocity2D_TypeSupportInterface &);
                Velocity2D_TypeSupportInterface & operator = (const Velocity2D_TypeSupportInterface &);
            };

            class  Velocity2D_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Velocity2D_DataWriter_ptr _ptr_type;
                typedef Velocity2D_DataWriter_var _var_type;

                static Velocity2D_DataWriter_ptr _duplicate (Velocity2D_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Velocity2D_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Velocity2D_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Velocity2D_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Velocity2D_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Velocity2D_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Velocity2D_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Velocity2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Velocity2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Velocity2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Velocity2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Velocity2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Velocity2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Velocity2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Velocity2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Velocity2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Velocity2D_& instance_data) = 0;

            protected:
                Velocity2D_DataWriter () {};
                ~Velocity2D_DataWriter () {};
            private:
                Velocity2D_DataWriter (const Velocity2D_DataWriter &);
                Velocity2D_DataWriter & operator = (const Velocity2D_DataWriter &);
            };

            class  Velocity2D_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Velocity2D_DataReader_ptr _ptr_type;
                typedef Velocity2D_DataReader_var _var_type;

                static Velocity2D_DataReader_ptr _duplicate (Velocity2D_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Velocity2D_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Velocity2D_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Velocity2D_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Velocity2D_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Velocity2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Velocity2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Velocity2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Velocity2D_& instance) = 0;

            protected:
                Velocity2D_DataReader () {};
                ~Velocity2D_DataReader () {};
            private:
                Velocity2D_DataReader (const Velocity2D_DataReader &);
                Velocity2D_DataReader & operator = (const Velocity2D_DataReader &);
            };

            class  Velocity2D_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Velocity2D_DataReaderView_ptr _ptr_type;
                typedef Velocity2D_DataReaderView_var _var_type;

                static Velocity2D_DataReaderView_ptr _duplicate (Velocity2D_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Velocity2D_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Velocity2D_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Velocity2D_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Velocity2D_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Velocity2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Velocity2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Velocity2D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Velocity2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Velocity2D_& instance) = 0;

            protected:
                Velocity2D_DataReaderView () {};
                ~Velocity2D_DataReaderView () {};
            private:
                Velocity2D_DataReaderView (const Velocity2D_DataReaderView &);
                Velocity2D_DataReaderView & operator = (const Velocity2D_DataReaderView &);
            };
        }

    }

}

#endif
