// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/HostVehicleState2807.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/host_vehicle_state2807__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `ibeo_header`
#include "ibeo_msgs/msg/ibeo_data_header__functions.h"
// Member `timestamp`
#include "builtin_interfaces/msg/time__functions.h"

bool
ibeo_msgs__msg__HostVehicleState2807__init(ibeo_msgs__msg__HostVehicleState2807 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ibeo_msgs__msg__HostVehicleState2807__fini(msg);
    return false;
  }
  // ibeo_header
  if (!ibeo_msgs__msg__IbeoDataHeader__init(&msg->ibeo_header)) {
    ibeo_msgs__msg__HostVehicleState2807__fini(msg);
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    ibeo_msgs__msg__HostVehicleState2807__fini(msg);
    return false;
  }
  // distance_x
  // distance_y
  // course_angle
  // longitudinal_velocity
  // yaw_rate
  // steering_wheel_angle
  // cross_acceleration
  // front_wheel_angle
  // vehicle_width
  // vehicle_front_to_front_axle
  // rear_axle_to_front_axle
  // rear_axle_to_vehicle_rear
  // steer_ratio_poly_0
  // steer_ratio_poly_1
  // steer_ratio_poly_2
  // steer_ratio_poly_3
  // longitudinal_acceleration
  return true;
}

void
ibeo_msgs__msg__HostVehicleState2807__fini(ibeo_msgs__msg__HostVehicleState2807 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ibeo_header
  ibeo_msgs__msg__IbeoDataHeader__fini(&msg->ibeo_header);
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // distance_x
  // distance_y
  // course_angle
  // longitudinal_velocity
  // yaw_rate
  // steering_wheel_angle
  // cross_acceleration
  // front_wheel_angle
  // vehicle_width
  // vehicle_front_to_front_axle
  // rear_axle_to_front_axle
  // rear_axle_to_vehicle_rear
  // steer_ratio_poly_0
  // steer_ratio_poly_1
  // steer_ratio_poly_2
  // steer_ratio_poly_3
  // longitudinal_acceleration
}

ibeo_msgs__msg__HostVehicleState2807 *
ibeo_msgs__msg__HostVehicleState2807__create()
{
  ibeo_msgs__msg__HostVehicleState2807 * msg = (ibeo_msgs__msg__HostVehicleState2807 *)malloc(sizeof(ibeo_msgs__msg__HostVehicleState2807));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__HostVehicleState2807));
  bool success = ibeo_msgs__msg__HostVehicleState2807__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__HostVehicleState2807__destroy(ibeo_msgs__msg__HostVehicleState2807 * msg)
{
  if (msg) {
    ibeo_msgs__msg__HostVehicleState2807__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__HostVehicleState2807__Sequence__init(ibeo_msgs__msg__HostVehicleState2807__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__HostVehicleState2807 * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__HostVehicleState2807 *)calloc(size, sizeof(ibeo_msgs__msg__HostVehicleState2807));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__HostVehicleState2807__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__HostVehicleState2807__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__HostVehicleState2807__Sequence__fini(ibeo_msgs__msg__HostVehicleState2807__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__HostVehicleState2807__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__HostVehicleState2807__Sequence *
ibeo_msgs__msg__HostVehicleState2807__Sequence__create(size_t size)
{
  ibeo_msgs__msg__HostVehicleState2807__Sequence * array = (ibeo_msgs__msg__HostVehicleState2807__Sequence *)malloc(sizeof(ibeo_msgs__msg__HostVehicleState2807__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__HostVehicleState2807__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__HostVehicleState2807__Sequence__destroy(ibeo_msgs__msg__HostVehicleState2807__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__HostVehicleState2807__Sequence__fini(array);
  }
  free(array);
}
