#ifndef _H_5C7735B8495BA5C1BC8F979FEBD9EEF0_ErrorWarning__H_
#define _H_5C7735B8495BA5C1BC8F979FEBD9EEF0_ErrorWarning__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  ErrorWarning_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::DDS::Boolean err_internal_error_;
                ::DDS::Boolean err_motor_1_fault_;
                ::DDS::Boolean err_buffer_error_xmt_incomplete_;
                ::DDS::Boolean err_buffer_error_overflow_;
                ::DDS::Boolean err_apd_over_temperature_;
                ::DDS::Boolean err_apd_under_temperature_;
                ::DDS::Boolean err_apd_temperature_sensor_defect_;
                ::DDS::Boolean err_motor_2_fault_;
                ::DDS::Boolean err_motor_3_fault_;
                ::DDS::Boolean err_motor_4_fault_;
                ::DDS::Boolean err_motor_5_fault_;
                ::DDS::Boolean err_int_no_scan_data_;
                ::DDS::Boolean err_int_communication_error_;
                ::DDS::Boolean err_int_incorrect_scan_data_;
                ::DDS::Boolean err_config_fpga_not_configurable_;
                ::DDS::Boolean err_config_incorrect_config_data_;
                ::DDS::Boolean err_config_contains_incorrect_params_;
                ::DDS::Boolean err_timeout_data_processing_;
                ::DDS::Boolean err_timeout_env_model_computation_reset_;
                ::DDS::Boolean wrn_int_communication_error_;
                ::DDS::Boolean wrn_low_temperature_;
                ::DDS::Boolean wrn_high_temperature_;
                ::DDS::Boolean wrn_int_motor_1_;
                ::DDS::Boolean wrn_sync_error_;
                ::DDS::Boolean wrn_laser_1_start_pulse_missing_;
                ::DDS::Boolean wrn_laser_2_start_pulse_missing_;
                ::DDS::Boolean wrn_can_interface_blocked_;
                ::DDS::Boolean wrn_eth_interface_blocked_;
                ::DDS::Boolean wrn_incorrect_can_data_rcvd_;
                ::DDS::Boolean wrn_int_incorrect_scan_data_;
                ::DDS::Boolean wrn_eth_unkwn_incomplete_data_;
                ::DDS::Boolean wrn_incorrect_or_forbidden_cmd_rcvd_;
                ::DDS::Boolean wrn_memory_access_failure_;
                ::DDS::Boolean wrn_int_overflow_;
                ::DDS::Boolean wrn_ego_motion_data_missing_;
                ::DDS::Boolean wrn_incorrect_mounting_params_;
                ::DDS::Boolean wrn_no_obj_comp_due_to_scan_freq_;
            };

            typedef DDS_DCPSStruct_var<ErrorWarning_> ErrorWarning__var;
            typedef DDS_DCPSStruct_out < ErrorWarning_> ErrorWarning__out;

        }

    }

}

#endif /* _H_5C7735B8495BA5C1BC8F979FEBD9EEF0_ErrorWarning__H_ */
