#ifndef H_5C7735B8495BA5C1BC8F979FEBD9EEF0_ErrorWarning_SPLTYPES_H
#define H_5C7735B8495BA5C1BC8F979FEBD9EEF0_ErrorWarning_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ErrorWarning_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_SplDcps.h"



extern c_metaObject __ErrorWarning__ibeo_msgs__load (c_base base);

extern c_metaObject __ErrorWarning__ibeo_msgs_msg__load (c_base base);

extern c_metaObject __ErrorWarning__ibeo_msgs_msg_dds___load (c_base base);

extern const char *ibeo_msgs_msg_dds__ErrorWarning__metaDescriptor[];
extern const int ibeo_msgs_msg_dds__ErrorWarning__metaDescriptorArrLength;
extern const int ibeo_msgs_msg_dds__ErrorWarning__metaDescriptorLength;
extern c_metaObject __ibeo_msgs_msg_dds__ErrorWarning___load (c_base base);
struct _ibeo_msgs_msg_dds__ErrorWarning_ ;
extern  v_copyin_result __ibeo_msgs_msg_dds__ErrorWarning___copyIn(c_base base, const struct ibeo_msgs::msg::dds_::ErrorWarning_ *from, struct _ibeo_msgs_msg_dds__ErrorWarning_ *to);
extern  void __ibeo_msgs_msg_dds__ErrorWarning___copyOut(const void *_from, void *_to);
struct _ibeo_msgs_msg_dds__ErrorWarning_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _ibeo_msgs_msg_dds__IbeoDataHeader_ ibeo_header_;
    c_bool err_internal_error_;
    c_bool err_motor_1_fault_;
    c_bool err_buffer_error_xmt_incomplete_;
    c_bool err_buffer_error_overflow_;
    c_bool err_apd_over_temperature_;
    c_bool err_apd_under_temperature_;
    c_bool err_apd_temperature_sensor_defect_;
    c_bool err_motor_2_fault_;
    c_bool err_motor_3_fault_;
    c_bool err_motor_4_fault_;
    c_bool err_motor_5_fault_;
    c_bool err_int_no_scan_data_;
    c_bool err_int_communication_error_;
    c_bool err_int_incorrect_scan_data_;
    c_bool err_config_fpga_not_configurable_;
    c_bool err_config_incorrect_config_data_;
    c_bool err_config_contains_incorrect_params_;
    c_bool err_timeout_data_processing_;
    c_bool err_timeout_env_model_computation_reset_;
    c_bool wrn_int_communication_error_;
    c_bool wrn_low_temperature_;
    c_bool wrn_high_temperature_;
    c_bool wrn_int_motor_1_;
    c_bool wrn_sync_error_;
    c_bool wrn_laser_1_start_pulse_missing_;
    c_bool wrn_laser_2_start_pulse_missing_;
    c_bool wrn_can_interface_blocked_;
    c_bool wrn_eth_interface_blocked_;
    c_bool wrn_incorrect_can_data_rcvd_;
    c_bool wrn_int_incorrect_scan_data_;
    c_bool wrn_eth_unkwn_incomplete_data_;
    c_bool wrn_incorrect_or_forbidden_cmd_rcvd_;
    c_bool wrn_memory_access_failure_;
    c_bool wrn_int_overflow_;
    c_bool wrn_ego_motion_data_missing_;
    c_bool wrn_incorrect_mounting_params_;
    c_bool wrn_no_obj_comp_due_to_scan_freq_;
};

#undef OS_API
#endif
