#ifndef _H_38A88E5D0A3C53F8681B3352C150BC5C_HostVehicleState2805__H_
#define _H_38A88E5D0A3C53F8681B3352C150BC5C_HostVehicleState2805__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  HostVehicleState2805_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::DDS::UShort scan_number_;
                ::DDS::UShort error_flags_;
                ::DDS::Double longitudinal_velocity_;
                ::DDS::Double steering_wheel_angle_;
                ::DDS::Double front_wheel_angle_;
                ::DDS::Long x_position_;
                ::DDS::Long y_position_;
                ::DDS::Short course_angle_;
                ::DDS::UShort time_difference_;
                ::DDS::Short x_difference_;
                ::DDS::Short y_difference_;
                ::DDS::Short heading_difference_;
                ::DDS::Short current_yaw_rate_;
            };

            typedef DDS_DCPSStruct_var<HostVehicleState2805_> HostVehicleState2805__var;
            typedef DDS_DCPSStruct_out < HostVehicleState2805_> HostVehicleState2805__out;

        }

    }

}

#endif /* _H_38A88E5D0A3C53F8681B3352C150BC5C_HostVehicleState2805__H_ */
