#ifndef _H_BFC29E1B99BD4CB027966CE4FB05C8A8_HostVehicleState2807__H_
#define _H_BFC29E1B99BD4CB027966CE4FB05C8A8_HostVehicleState2807__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  HostVehicleState2807_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::DDS::Long distance_x_;
                ::DDS::Long distance_y_;
                ::DDS::Float course_angle_;
                ::DDS::Float longitudinal_velocity_;
                ::DDS::Float yaw_rate_;
                ::DDS::Float steering_wheel_angle_;
                ::DDS::Float cross_acceleration_;
                ::DDS::Float front_wheel_angle_;
                ::DDS::Float vehicle_width_;
                ::DDS::Float vehicle_front_to_front_axle_;
                ::DDS::Float rear_axle_to_front_axle_;
                ::DDS::Float rear_axle_to_vehicle_rear_;
                ::DDS::Float steer_ratio_poly_0_;
                ::DDS::Float steer_ratio_poly_1_;
                ::DDS::Float steer_ratio_poly_2_;
                ::DDS::Float steer_ratio_poly_3_;
                ::DDS::Float longitudinal_acceleration_;
            };

            typedef DDS_DCPSStruct_var<HostVehicleState2807_> HostVehicleState2807__var;
            typedef DDS_DCPSStruct_out < HostVehicleState2807_> HostVehicleState2807__out;

        }

    }

}

#endif /* _H_BFC29E1B99BD4CB027966CE4FB05C8A8_HostVehicleState2807__H_ */
