#ifndef _H_6DFC8E0042CCE75B91AD3AA535E98F64_IbeoDataHeader_DCPS_H_
#define _H_6DFC8E0042CCE75B91AD3AA535E98F64_IbeoDataHeader_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IbeoDataHeader_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class IbeoDataHeader_TypeSupportInterface;

            typedef IbeoDataHeader_TypeSupportInterface * IbeoDataHeader_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IbeoDataHeader_TypeSupportInterface> IbeoDataHeader_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IbeoDataHeader_TypeSupportInterface> IbeoDataHeader_TypeSupportInterface_out;


            class IbeoDataHeader_DataWriter;

            typedef IbeoDataHeader_DataWriter * IbeoDataHeader_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IbeoDataHeader_DataWriter> IbeoDataHeader_DataWriter_var;
            typedef DDS_DCPSInterface_out < IbeoDataHeader_DataWriter> IbeoDataHeader_DataWriter_out;


            class IbeoDataHeader_DataReader;

            typedef IbeoDataHeader_DataReader * IbeoDataHeader_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IbeoDataHeader_DataReader> IbeoDataHeader_DataReader_var;
            typedef DDS_DCPSInterface_out < IbeoDataHeader_DataReader> IbeoDataHeader_DataReader_out;


            class IbeoDataHeader_DataReaderView;

            typedef IbeoDataHeader_DataReaderView * IbeoDataHeader_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IbeoDataHeader_DataReaderView> IbeoDataHeader_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IbeoDataHeader_DataReaderView> IbeoDataHeader_DataReaderView_out;

            struct IbeoDataHeader_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < IbeoDataHeader_, struct IbeoDataHeader_Seq_uniq_> IbeoDataHeader_Seq;
            typedef DDS_DCPSSequence_var < IbeoDataHeader_Seq> IbeoDataHeader_Seq_var;
            typedef DDS_DCPSSequence_out < IbeoDataHeader_Seq> IbeoDataHeader_Seq_out;

            class  IbeoDataHeader_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IbeoDataHeader_TypeSupportInterface_ptr _ptr_type;
                typedef IbeoDataHeader_TypeSupportInterface_var _var_type;

                static IbeoDataHeader_TypeSupportInterface_ptr _duplicate (IbeoDataHeader_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IbeoDataHeader_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IbeoDataHeader_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IbeoDataHeader_TypeSupportInterface () {};
                ~IbeoDataHeader_TypeSupportInterface () {};
            private:
                IbeoDataHeader_TypeSupportInterface (const IbeoDataHeader_TypeSupportInterface &);
                IbeoDataHeader_TypeSupportInterface & operator = (const IbeoDataHeader_TypeSupportInterface &);
            };

            class  IbeoDataHeader_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IbeoDataHeader_DataWriter_ptr _ptr_type;
                typedef IbeoDataHeader_DataWriter_var _var_type;

                static IbeoDataHeader_DataWriter_ptr _duplicate (IbeoDataHeader_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IbeoDataHeader_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IbeoDataHeader_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IbeoDataHeader_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IbeoDataHeader_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IbeoDataHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IbeoDataHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IbeoDataHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IbeoDataHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IbeoDataHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IbeoDataHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IbeoDataHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IbeoDataHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IbeoDataHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IbeoDataHeader_& instance_data) = 0;

            protected:
                IbeoDataHeader_DataWriter () {};
                ~IbeoDataHeader_DataWriter () {};
            private:
                IbeoDataHeader_DataWriter (const IbeoDataHeader_DataWriter &);
                IbeoDataHeader_DataWriter & operator = (const IbeoDataHeader_DataWriter &);
            };

            class  IbeoDataHeader_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IbeoDataHeader_DataReader_ptr _ptr_type;
                typedef IbeoDataHeader_DataReader_var _var_type;

                static IbeoDataHeader_DataReader_ptr _duplicate (IbeoDataHeader_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IbeoDataHeader_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IbeoDataHeader_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IbeoDataHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IbeoDataHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IbeoDataHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IbeoDataHeader_& instance) = 0;

            protected:
                IbeoDataHeader_DataReader () {};
                ~IbeoDataHeader_DataReader () {};
            private:
                IbeoDataHeader_DataReader (const IbeoDataHeader_DataReader &);
                IbeoDataHeader_DataReader & operator = (const IbeoDataHeader_DataReader &);
            };

            class  IbeoDataHeader_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IbeoDataHeader_DataReaderView_ptr _ptr_type;
                typedef IbeoDataHeader_DataReaderView_var _var_type;

                static IbeoDataHeader_DataReaderView_ptr _duplicate (IbeoDataHeader_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IbeoDataHeader_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IbeoDataHeader_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IbeoDataHeader_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IbeoDataHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IbeoDataHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IbeoDataHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IbeoDataHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IbeoDataHeader_& instance) = 0;

            protected:
                IbeoDataHeader_DataReaderView () {};
                ~IbeoDataHeader_DataReaderView () {};
            private:
                IbeoDataHeader_DataReaderView (const IbeoDataHeader_DataReaderView &);
                IbeoDataHeader_DataReaderView & operator = (const IbeoDataHeader_DataReaderView &);
            };
        }

    }

}

#endif
