#ifndef _H_501E27CAA6903D770597772B046E5F84_Object2221__H_
#define _H_501E27CAA6903D770597772B046E5F84_Object2221__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "ibeo_msgs/msg/dds_opensplice/Point2Di_.h"
#include "ibeo_msgs/msg/dds_opensplice/Size2D_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Object2221_Constants
            {
                const ::DDS::Octet UNCLASSIFIED_ = 0;

                const ::DDS::Octet UNKNOWN_SMALL_ = 1;

                const ::DDS::Octet UNKNOWN_BIG_ = 2;

                const ::DDS::Octet PEDESTRIAN_ = 3;

                const ::DDS::Octet BIKE_ = 4;

                const ::DDS::Octet CAR_ = 5;

                const ::DDS::Octet TRUCK_ = 6;

            }

            struct  Object2221_
            {
                struct _contour_point_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::Point2Di_, struct _contour_point_list__seq_uniq_ > _contour_point_list__seq;
                typedef DDS_DCPSSequence_var< _contour_point_list__seq > _contour_point_list__seq_var;
                typedef DDS_DCPSSequence_out< _contour_point_list__seq > _contour_point_list__seq_out;
                ::DDS::UShort id_;
                ::DDS::UShort age_;
                ::DDS::UShort prediction_age_;
                ::DDS::UShort relative_timestamp_;
                ::ibeo_msgs::msg::dds_::Point2Di_ reference_point_;
                ::ibeo_msgs::msg::dds_::Point2Di_ reference_point_sigma_;
                ::ibeo_msgs::msg::dds_::Point2Di_ closest_point_;
                ::ibeo_msgs::msg::dds_::Point2Di_ bounding_box_center_;
                ::DDS::UShort bounding_box_width_;
                ::DDS::UShort bounding_box_length_;
                ::ibeo_msgs::msg::dds_::Point2Di_ object_box_center_;
                ::ibeo_msgs::msg::dds_::Size2D_ object_box_size_;
                ::DDS::Short object_box_orientation_;
                ::ibeo_msgs::msg::dds_::Point2Di_ absolute_velocity_;
                ::ibeo_msgs::msg::dds_::Size2D_ absolute_velocity_sigma_;
                ::ibeo_msgs::msg::dds_::Point2Di_ relative_velocity_;
                ::DDS::Octet classification_;
                ::DDS::UShort classification_age_;
                ::DDS::UShort classification_certainty_;
                ::DDS::UShort number_of_contour_points_;
                _contour_point_list__seq contour_point_list_;
            };

            typedef DDS_DCPSStruct_var<Object2221_> Object2221__var;
            typedef DDS_DCPSStruct_out < Object2221_> Object2221__out;

        }

    }

}

#endif /* _H_501E27CAA6903D770597772B046E5F84_Object2221__H_ */
