#ifndef _H_453D457BA454B31C8E27DF0427252516_Object2225__H_
#define _H_453D457BA454B31C8E27DF0427252516_Object2225__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "ibeo_msgs/msg/dds_opensplice/Point2Df_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Object2225_Constants
            {
                const ::DDS::Octet UNCLASSIFIED_ = 0;

                const ::DDS::Octet UNKNOWN_SMALL_ = 1;

                const ::DDS::Octet UNKNOWN_BIG_ = 2;

                const ::DDS::Octet PEDESTRIAN_ = 3;

                const ::DDS::Octet BIKE_ = 4;

                const ::DDS::Octet CAR_ = 5;

                const ::DDS::Octet TRUCK_ = 6;

            }

            struct  Object2225_
            {
                struct _contour_point_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::Point2Df_, struct _contour_point_list__seq_uniq_ > _contour_point_list__seq;
                typedef DDS_DCPSSequence_var< _contour_point_list__seq > _contour_point_list__seq_var;
                typedef DDS_DCPSSequence_out< _contour_point_list__seq > _contour_point_list__seq_out;
                ::DDS::UShort id_;
                ::DDS::ULong age_;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::DDS::UShort hidden_status_age_;
                ::DDS::Octet classification_;
                ::DDS::Octet classification_certainty_;
                ::DDS::ULong classification_age_;
                ::ibeo_msgs::msg::dds_::Point2Df_ bounding_box_center_;
                ::ibeo_msgs::msg::dds_::Point2Df_ bounding_box_size_;
                ::ibeo_msgs::msg::dds_::Point2Df_ object_box_center_;
                ::ibeo_msgs::msg::dds_::Point2Df_ object_box_center_sigma_;
                ::ibeo_msgs::msg::dds_::Point2Df_ object_box_size_;
                ::DDS::Float yaw_angle_;
                ::ibeo_msgs::msg::dds_::Point2Df_ relative_velocity_;
                ::ibeo_msgs::msg::dds_::Point2Df_ relative_velocity_sigma_;
                ::ibeo_msgs::msg::dds_::Point2Df_ absolute_velocity_;
                ::ibeo_msgs::msg::dds_::Point2Df_ absolute_velocity_sigma_;
                ::DDS::Octet number_of_contour_points_;
                ::DDS::Octet closest_point_index_;
                _contour_point_list__seq contour_point_list_;
            };

            typedef DDS_DCPSStruct_var<Object2225_> Object2225__var;
            typedef DDS_DCPSStruct_out < Object2225_> Object2225__out;

        }

    }

}

#endif /* _H_453D457BA454B31C8E27DF0427252516_Object2225__H_ */
