#ifndef _H_A13EC519F382DCA7F71076AD0AAC32C2_Object2280_DCPS_H_
#define _H_A13EC519F382DCA7F71076AD0AAC32C2_Object2280_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Object2280_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Object2280_TypeSupportInterface;

            typedef Object2280_TypeSupportInterface * Object2280_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Object2280_TypeSupportInterface> Object2280_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Object2280_TypeSupportInterface> Object2280_TypeSupportInterface_out;


            class Object2280_DataWriter;

            typedef Object2280_DataWriter * Object2280_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Object2280_DataWriter> Object2280_DataWriter_var;
            typedef DDS_DCPSInterface_out < Object2280_DataWriter> Object2280_DataWriter_out;


            class Object2280_DataReader;

            typedef Object2280_DataReader * Object2280_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Object2280_DataReader> Object2280_DataReader_var;
            typedef DDS_DCPSInterface_out < Object2280_DataReader> Object2280_DataReader_out;


            class Object2280_DataReaderView;

            typedef Object2280_DataReaderView * Object2280_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Object2280_DataReaderView> Object2280_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Object2280_DataReaderView> Object2280_DataReaderView_out;

            struct Object2280_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Object2280_, struct Object2280_Seq_uniq_> Object2280_Seq;
            typedef DDS_DCPSSequence_var < Object2280_Seq> Object2280_Seq_var;
            typedef DDS_DCPSSequence_out < Object2280_Seq> Object2280_Seq_out;

            class  Object2280_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Object2280_TypeSupportInterface_ptr _ptr_type;
                typedef Object2280_TypeSupportInterface_var _var_type;

                static Object2280_TypeSupportInterface_ptr _duplicate (Object2280_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2280_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Object2280_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2280_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2280_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Object2280_TypeSupportInterface () {};
                ~Object2280_TypeSupportInterface () {};
            private:
                Object2280_TypeSupportInterface (const Object2280_TypeSupportInterface &);
                Object2280_TypeSupportInterface & operator = (const Object2280_TypeSupportInterface &);
            };

            class  Object2280_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Object2280_DataWriter_ptr _ptr_type;
                typedef Object2280_DataWriter_var _var_type;

                static Object2280_DataWriter_ptr _duplicate (Object2280_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2280_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Object2280_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2280_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2280_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Object2280_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Object2280_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Object2280_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Object2280_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Object2280_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Object2280_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Object2280_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Object2280_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Object2280_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Object2280_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Object2280_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Object2280_& instance_data) = 0;

            protected:
                Object2280_DataWriter () {};
                ~Object2280_DataWriter () {};
            private:
                Object2280_DataWriter (const Object2280_DataWriter &);
                Object2280_DataWriter & operator = (const Object2280_DataWriter &);
            };

            class  Object2280_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Object2280_DataReader_ptr _ptr_type;
                typedef Object2280_DataReader_var _var_type;

                static Object2280_DataReader_ptr _duplicate (Object2280_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2280_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Object2280_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2280_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2280_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Object2280_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Object2280_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Object2280_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Object2280_& instance) = 0;

            protected:
                Object2280_DataReader () {};
                ~Object2280_DataReader () {};
            private:
                Object2280_DataReader (const Object2280_DataReader &);
                Object2280_DataReader & operator = (const Object2280_DataReader &);
            };

            class  Object2280_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Object2280_DataReaderView_ptr _ptr_type;
                typedef Object2280_DataReaderView_var _var_type;

                static Object2280_DataReaderView_ptr _duplicate (Object2280_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Object2280_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Object2280_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Object2280_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Object2280_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Object2280_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Object2280_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Object2280_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Object2280_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Object2280_& instance) = 0;

            protected:
                Object2280_DataReaderView () {};
                ~Object2280_DataReaderView () {};
            private:
                Object2280_DataReaderView (const Object2280_DataReaderView &);
                Object2280_DataReaderView & operator = (const Object2280_DataReaderView &);
            };
        }

    }

}

#endif
