#ifndef H_A13EC519F382DCA7F71076AD0AAC32C2_Object2280_SPLTYPES_H
#define H_A13EC519F382DCA7F71076AD0AAC32C2_Object2280_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_Object2280_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/Point2Df_SplDcps.h"



extern c_metaObject __Object2280__ibeo_msgs__load (c_base base);

extern c_metaObject __Object2280__ibeo_msgs_msg__load (c_base base);

extern c_metaObject __Object2280__ibeo_msgs_msg_dds___load (c_base base);

extern c_metaObject __Object2280__ibeo_msgs_msg_dds__Object2280_Constants__load (c_base base);

extern const char *ibeo_msgs_msg_dds__Object2280__metaDescriptor[];
extern const int ibeo_msgs_msg_dds__Object2280__metaDescriptorArrLength;
extern const int ibeo_msgs_msg_dds__Object2280__metaDescriptorLength;
extern c_metaObject __ibeo_msgs_msg_dds__Object2280___load (c_base base);
struct _ibeo_msgs_msg_dds__Object2280_ ;
extern  v_copyin_result __ibeo_msgs_msg_dds__Object2280___copyIn(c_base base, const struct ibeo_msgs::msg::dds_::Object2280_ *from, struct _ibeo_msgs_msg_dds__Object2280_ *to);
extern  void __ibeo_msgs_msg_dds__Object2280___copyOut(const void *_from, void *_to);
struct _ibeo_msgs_msg_dds__Object2280_ {
    c_ushort id_;
    c_octet tracking_model_;
    c_bool mobility_of_dyn_object_detected_;
    c_bool motion_model_validated_;
    c_ulong object_age_;
    struct _builtin_interfaces_msg_dds__Time_ timestamp_;
    c_ushort object_prediction_age_;
    c_octet classification_;
    c_octet classification_certainty_;
    c_ulong classification_age_;
    struct _ibeo_msgs_msg_dds__Point2Df_ object_box_center_;
    struct _ibeo_msgs_msg_dds__Point2Df_ object_box_center_sigma_;
    struct _ibeo_msgs_msg_dds__Point2Df_ object_box_size_;
    c_float object_box_orientation_angle_;
    c_float object_box_orientation_angle_sigma_;
    struct _ibeo_msgs_msg_dds__Point2Df_ relative_velocity_;
    struct _ibeo_msgs_msg_dds__Point2Df_ relative_velocity_sigma_;
    struct _ibeo_msgs_msg_dds__Point2Df_ absolute_velocity_;
    struct _ibeo_msgs_msg_dds__Point2Df_ absolute_velocity_sigma_;
    c_octet number_of_contour_points_;
    c_octet closest_point_index_;
    c_ushort reference_point_location_;
    struct _ibeo_msgs_msg_dds__Point2Df_ reference_point_coordinate_;
    struct _ibeo_msgs_msg_dds__Point2Df_ reference_point_coordinate_sigma_;
    c_float reference_point_position_correction_coefficient_;
    c_ushort object_priority_;
    c_float object_existence_measurement_;
    c_sequence contour_point_list_;
};

#undef OS_API
#endif
