#ifndef _H_65EE47A2355ACFA9A604E26AC06CA7E6_ObjectData2225_DCPS_H_
#define _H_65EE47A2355ACFA9A604E26AC06CA7E6_ObjectData2225_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObjectData2225_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObjectData2225_TypeSupportInterface;

            typedef ObjectData2225_TypeSupportInterface * ObjectData2225_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2225_TypeSupportInterface> ObjectData2225_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObjectData2225_TypeSupportInterface> ObjectData2225_TypeSupportInterface_out;


            class ObjectData2225_DataWriter;

            typedef ObjectData2225_DataWriter * ObjectData2225_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2225_DataWriter> ObjectData2225_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObjectData2225_DataWriter> ObjectData2225_DataWriter_out;


            class ObjectData2225_DataReader;

            typedef ObjectData2225_DataReader * ObjectData2225_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2225_DataReader> ObjectData2225_DataReader_var;
            typedef DDS_DCPSInterface_out < ObjectData2225_DataReader> ObjectData2225_DataReader_out;


            class ObjectData2225_DataReaderView;

            typedef ObjectData2225_DataReaderView * ObjectData2225_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2225_DataReaderView> ObjectData2225_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObjectData2225_DataReaderView> ObjectData2225_DataReaderView_out;

            struct ObjectData2225_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObjectData2225_, struct ObjectData2225_Seq_uniq_> ObjectData2225_Seq;
            typedef DDS_DCPSSequence_var < ObjectData2225_Seq> ObjectData2225_Seq_var;
            typedef DDS_DCPSSequence_out < ObjectData2225_Seq> ObjectData2225_Seq_out;

            class  ObjectData2225_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObjectData2225_TypeSupportInterface_ptr _ptr_type;
                typedef ObjectData2225_TypeSupportInterface_var _var_type;

                static ObjectData2225_TypeSupportInterface_ptr _duplicate (ObjectData2225_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2225_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2225_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2225_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2225_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObjectData2225_TypeSupportInterface () {};
                ~ObjectData2225_TypeSupportInterface () {};
            private:
                ObjectData2225_TypeSupportInterface (const ObjectData2225_TypeSupportInterface &);
                ObjectData2225_TypeSupportInterface & operator = (const ObjectData2225_TypeSupportInterface &);
            };

            class  ObjectData2225_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObjectData2225_DataWriter_ptr _ptr_type;
                typedef ObjectData2225_DataWriter_var _var_type;

                static ObjectData2225_DataWriter_ptr _duplicate (ObjectData2225_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2225_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2225_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2225_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2225_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObjectData2225_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObjectData2225_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObjectData2225_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObjectData2225_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObjectData2225_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObjectData2225_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObjectData2225_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObjectData2225_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObjectData2225_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObjectData2225_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObjectData2225_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2225_& instance_data) = 0;

            protected:
                ObjectData2225_DataWriter () {};
                ~ObjectData2225_DataWriter () {};
            private:
                ObjectData2225_DataWriter (const ObjectData2225_DataWriter &);
                ObjectData2225_DataWriter & operator = (const ObjectData2225_DataWriter &);
            };

            class  ObjectData2225_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObjectData2225_DataReader_ptr _ptr_type;
                typedef ObjectData2225_DataReader_var _var_type;

                static ObjectData2225_DataReader_ptr _duplicate (ObjectData2225_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2225_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2225_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2225_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2225_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2225_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2225_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2225_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2225_& instance) = 0;

            protected:
                ObjectData2225_DataReader () {};
                ~ObjectData2225_DataReader () {};
            private:
                ObjectData2225_DataReader (const ObjectData2225_DataReader &);
                ObjectData2225_DataReader & operator = (const ObjectData2225_DataReader &);
            };

            class  ObjectData2225_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObjectData2225_DataReaderView_ptr _ptr_type;
                typedef ObjectData2225_DataReaderView_var _var_type;

                static ObjectData2225_DataReaderView_ptr _duplicate (ObjectData2225_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2225_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2225_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2225_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2225_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2225_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2225_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2225_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2225_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2225_& instance) = 0;

            protected:
                ObjectData2225_DataReaderView () {};
                ~ObjectData2225_DataReaderView () {};
            private:
                ObjectData2225_DataReaderView (const ObjectData2225_DataReaderView &);
                ObjectData2225_DataReaderView & operator = (const ObjectData2225_DataReaderView &);
            };
        }

    }

}

#endif
