#ifndef _H_9E8E5C1D0A37A5A86E21FE70F031C0DB_ObjectData2271_DCPS_H_
#define _H_9E8E5C1D0A37A5A86E21FE70F031C0DB_ObjectData2271_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObjectData2271_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObjectData2271_TypeSupportInterface;

            typedef ObjectData2271_TypeSupportInterface * ObjectData2271_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2271_TypeSupportInterface> ObjectData2271_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObjectData2271_TypeSupportInterface> ObjectData2271_TypeSupportInterface_out;


            class ObjectData2271_DataWriter;

            typedef ObjectData2271_DataWriter * ObjectData2271_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2271_DataWriter> ObjectData2271_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObjectData2271_DataWriter> ObjectData2271_DataWriter_out;


            class ObjectData2271_DataReader;

            typedef ObjectData2271_DataReader * ObjectData2271_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2271_DataReader> ObjectData2271_DataReader_var;
            typedef DDS_DCPSInterface_out < ObjectData2271_DataReader> ObjectData2271_DataReader_out;


            class ObjectData2271_DataReaderView;

            typedef ObjectData2271_DataReaderView * ObjectData2271_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObjectData2271_DataReaderView> ObjectData2271_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObjectData2271_DataReaderView> ObjectData2271_DataReaderView_out;

            struct ObjectData2271_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObjectData2271_, struct ObjectData2271_Seq_uniq_> ObjectData2271_Seq;
            typedef DDS_DCPSSequence_var < ObjectData2271_Seq> ObjectData2271_Seq_var;
            typedef DDS_DCPSSequence_out < ObjectData2271_Seq> ObjectData2271_Seq_out;

            class  ObjectData2271_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObjectData2271_TypeSupportInterface_ptr _ptr_type;
                typedef ObjectData2271_TypeSupportInterface_var _var_type;

                static ObjectData2271_TypeSupportInterface_ptr _duplicate (ObjectData2271_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2271_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2271_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2271_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2271_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObjectData2271_TypeSupportInterface () {};
                ~ObjectData2271_TypeSupportInterface () {};
            private:
                ObjectData2271_TypeSupportInterface (const ObjectData2271_TypeSupportInterface &);
                ObjectData2271_TypeSupportInterface & operator = (const ObjectData2271_TypeSupportInterface &);
            };

            class  ObjectData2271_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObjectData2271_DataWriter_ptr _ptr_type;
                typedef ObjectData2271_DataWriter_var _var_type;

                static ObjectData2271_DataWriter_ptr _duplicate (ObjectData2271_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2271_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2271_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2271_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2271_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObjectData2271_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObjectData2271_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObjectData2271_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObjectData2271_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObjectData2271_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObjectData2271_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObjectData2271_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObjectData2271_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObjectData2271_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObjectData2271_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObjectData2271_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2271_& instance_data) = 0;

            protected:
                ObjectData2271_DataWriter () {};
                ~ObjectData2271_DataWriter () {};
            private:
                ObjectData2271_DataWriter (const ObjectData2271_DataWriter &);
                ObjectData2271_DataWriter & operator = (const ObjectData2271_DataWriter &);
            };

            class  ObjectData2271_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObjectData2271_DataReader_ptr _ptr_type;
                typedef ObjectData2271_DataReader_var _var_type;

                static ObjectData2271_DataReader_ptr _duplicate (ObjectData2271_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2271_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2271_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2271_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2271_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2271_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2271_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2271_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2271_& instance) = 0;

            protected:
                ObjectData2271_DataReader () {};
                ~ObjectData2271_DataReader () {};
            private:
                ObjectData2271_DataReader (const ObjectData2271_DataReader &);
                ObjectData2271_DataReader & operator = (const ObjectData2271_DataReader &);
            };

            class  ObjectData2271_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObjectData2271_DataReaderView_ptr _ptr_type;
                typedef ObjectData2271_DataReaderView_var _var_type;

                static ObjectData2271_DataReaderView_ptr _duplicate (ObjectData2271_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectData2271_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObjectData2271_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectData2271_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectData2271_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectData2271_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectData2271_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectData2271_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectData2271_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectData2271_& instance) = 0;

            protected:
                ObjectData2271_DataReaderView () {};
                ~ObjectData2271_DataReaderView () {};
            private:
                ObjectData2271_DataReaderView (const ObjectData2271_DataReaderView &);
                ObjectData2271_DataReaderView & operator = (const ObjectData2271_DataReaderView &);
            };
        }

    }

}

#endif
