#ifndef _H_883B9D371B84C38827196F1898F1FE28_Point2Df_DCPS_H_
#define _H_883B9D371B84C38827196F1898F1FE28_Point2Df_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Point2Df_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Point2Df_TypeSupportInterface;

            typedef Point2Df_TypeSupportInterface * Point2Df_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Point2Df_TypeSupportInterface> Point2Df_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Point2Df_TypeSupportInterface> Point2Df_TypeSupportInterface_out;


            class Point2Df_DataWriter;

            typedef Point2Df_DataWriter * Point2Df_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Point2Df_DataWriter> Point2Df_DataWriter_var;
            typedef DDS_DCPSInterface_out < Point2Df_DataWriter> Point2Df_DataWriter_out;


            class Point2Df_DataReader;

            typedef Point2Df_DataReader * Point2Df_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Point2Df_DataReader> Point2Df_DataReader_var;
            typedef DDS_DCPSInterface_out < Point2Df_DataReader> Point2Df_DataReader_out;


            class Point2Df_DataReaderView;

            typedef Point2Df_DataReaderView * Point2Df_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Point2Df_DataReaderView> Point2Df_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Point2Df_DataReaderView> Point2Df_DataReaderView_out;

            struct Point2Df_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Point2Df_, struct Point2Df_Seq_uniq_> Point2Df_Seq;
            typedef DDS_DCPSSequence_var < Point2Df_Seq> Point2Df_Seq_var;
            typedef DDS_DCPSSequence_out < Point2Df_Seq> Point2Df_Seq_out;

            class  Point2Df_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Point2Df_TypeSupportInterface_ptr _ptr_type;
                typedef Point2Df_TypeSupportInterface_var _var_type;

                static Point2Df_TypeSupportInterface_ptr _duplicate (Point2Df_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Df_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Point2Df_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Df_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Df_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Point2Df_TypeSupportInterface () {};
                ~Point2Df_TypeSupportInterface () {};
            private:
                Point2Df_TypeSupportInterface (const Point2Df_TypeSupportInterface &);
                Point2Df_TypeSupportInterface & operator = (const Point2Df_TypeSupportInterface &);
            };

            class  Point2Df_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Point2Df_DataWriter_ptr _ptr_type;
                typedef Point2Df_DataWriter_var _var_type;

                static Point2Df_DataWriter_ptr _duplicate (Point2Df_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Df_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Point2Df_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Df_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Df_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Point2Df_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Point2Df_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Point2Df_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Point2Df_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Point2Df_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Point2Df_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Point2Df_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Point2Df_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Point2Df_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Point2Df_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Point2Df_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Point2Df_& instance_data) = 0;

            protected:
                Point2Df_DataWriter () {};
                ~Point2Df_DataWriter () {};
            private:
                Point2Df_DataWriter (const Point2Df_DataWriter &);
                Point2Df_DataWriter & operator = (const Point2Df_DataWriter &);
            };

            class  Point2Df_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Point2Df_DataReader_ptr _ptr_type;
                typedef Point2Df_DataReader_var _var_type;

                static Point2Df_DataReader_ptr _duplicate (Point2Df_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Df_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Point2Df_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Df_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Df_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Point2Df_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Point2Df_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Point2Df_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Point2Df_& instance) = 0;

            protected:
                Point2Df_DataReader () {};
                ~Point2Df_DataReader () {};
            private:
                Point2Df_DataReader (const Point2Df_DataReader &);
                Point2Df_DataReader & operator = (const Point2Df_DataReader &);
            };

            class  Point2Df_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Point2Df_DataReaderView_ptr _ptr_type;
                typedef Point2Df_DataReaderView_var _var_type;

                static Point2Df_DataReaderView_ptr _duplicate (Point2Df_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Point2Df_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Point2Df_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Point2Df_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Point2Df_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Point2Df_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Point2Df_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Point2Df_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Point2Df_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Point2Df_& instance) = 0;

            protected:
                Point2Df_DataReaderView () {};
                ~Point2Df_DataReaderView () {};
            private:
                Point2Df_DataReaderView (const Point2Df_DataReaderView &);
                Point2Df_DataReaderView & operator = (const Point2Df_DataReaderView &);
            };
        }

    }

}

#endif
