#ifndef _H_477F7E208F0722ACE712336EBC1C9A95_ScanData2202_DCPS_H_
#define _H_477F7E208F0722ACE712336EBC1C9A95_ScanData2202_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScanData2202_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScanData2202_TypeSupportInterface;

            typedef ScanData2202_TypeSupportInterface * ScanData2202_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScanData2202_TypeSupportInterface> ScanData2202_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScanData2202_TypeSupportInterface> ScanData2202_TypeSupportInterface_out;


            class ScanData2202_DataWriter;

            typedef ScanData2202_DataWriter * ScanData2202_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScanData2202_DataWriter> ScanData2202_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScanData2202_DataWriter> ScanData2202_DataWriter_out;


            class ScanData2202_DataReader;

            typedef ScanData2202_DataReader * ScanData2202_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScanData2202_DataReader> ScanData2202_DataReader_var;
            typedef DDS_DCPSInterface_out < ScanData2202_DataReader> ScanData2202_DataReader_out;


            class ScanData2202_DataReaderView;

            typedef ScanData2202_DataReaderView * ScanData2202_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScanData2202_DataReaderView> ScanData2202_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScanData2202_DataReaderView> ScanData2202_DataReaderView_out;

            struct ScanData2202_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ScanData2202_, struct ScanData2202_Seq_uniq_> ScanData2202_Seq;
            typedef DDS_DCPSSequence_var < ScanData2202_Seq> ScanData2202_Seq_var;
            typedef DDS_DCPSSequence_out < ScanData2202_Seq> ScanData2202_Seq_out;

            class  ScanData2202_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScanData2202_TypeSupportInterface_ptr _ptr_type;
                typedef ScanData2202_TypeSupportInterface_var _var_type;

                static ScanData2202_TypeSupportInterface_ptr _duplicate (ScanData2202_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2202_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2202_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2202_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2202_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScanData2202_TypeSupportInterface () {};
                ~ScanData2202_TypeSupportInterface () {};
            private:
                ScanData2202_TypeSupportInterface (const ScanData2202_TypeSupportInterface &);
                ScanData2202_TypeSupportInterface & operator = (const ScanData2202_TypeSupportInterface &);
            };

            class  ScanData2202_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScanData2202_DataWriter_ptr _ptr_type;
                typedef ScanData2202_DataWriter_var _var_type;

                static ScanData2202_DataWriter_ptr _duplicate (ScanData2202_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2202_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2202_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2202_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2202_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScanData2202_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScanData2202_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScanData2202_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScanData2202_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScanData2202_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScanData2202_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScanData2202_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScanData2202_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScanData2202_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScanData2202_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScanData2202_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2202_& instance_data) = 0;

            protected:
                ScanData2202_DataWriter () {};
                ~ScanData2202_DataWriter () {};
            private:
                ScanData2202_DataWriter (const ScanData2202_DataWriter &);
                ScanData2202_DataWriter & operator = (const ScanData2202_DataWriter &);
            };

            class  ScanData2202_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScanData2202_DataReader_ptr _ptr_type;
                typedef ScanData2202_DataReader_var _var_type;

                static ScanData2202_DataReader_ptr _duplicate (ScanData2202_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2202_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2202_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2202_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2202_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2202_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2202_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2202_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2202_& instance) = 0;

            protected:
                ScanData2202_DataReader () {};
                ~ScanData2202_DataReader () {};
            private:
                ScanData2202_DataReader (const ScanData2202_DataReader &);
                ScanData2202_DataReader & operator = (const ScanData2202_DataReader &);
            };

            class  ScanData2202_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScanData2202_DataReaderView_ptr _ptr_type;
                typedef ScanData2202_DataReaderView_var _var_type;

                static ScanData2202_DataReaderView_ptr _duplicate (ScanData2202_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2202_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2202_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2202_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2202_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2202_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2202_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2202_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2202_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2202_& instance) = 0;

            protected:
                ScanData2202_DataReaderView () {};
                ~ScanData2202_DataReaderView () {};
            private:
                ScanData2202_DataReaderView (const ScanData2202_DataReaderView &);
                ScanData2202_DataReaderView & operator = (const ScanData2202_DataReaderView &);
            };
        }

    }

}

#endif
