#ifndef H_477F7E208F0722ACE712336EBC1C9A95_ScanData2202_SPLTYPES_H
#define H_477F7E208F0722ACE712336EBC1C9A95_ScanData2202_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ScanData2202_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/ScanPoint2202_SplDcps.h"



extern c_metaObject __ScanData2202__ibeo_msgs__load (c_base base);

extern c_metaObject __ScanData2202__ibeo_msgs_msg__load (c_base base);

extern c_metaObject __ScanData2202__ibeo_msgs_msg_dds___load (c_base base);

extern c_metaObject __ScanData2202__ibeo_msgs_msg_dds__ScanData2202_Constants__load (c_base base);

extern const char *ibeo_msgs_msg_dds__ScanData2202__metaDescriptor[];
extern const int ibeo_msgs_msg_dds__ScanData2202__metaDescriptorArrLength;
extern const int ibeo_msgs_msg_dds__ScanData2202__metaDescriptorLength;
extern c_metaObject __ibeo_msgs_msg_dds__ScanData2202___load (c_base base);
struct _ibeo_msgs_msg_dds__ScanData2202_ ;
extern  v_copyin_result __ibeo_msgs_msg_dds__ScanData2202___copyIn(c_base base, const struct ibeo_msgs::msg::dds_::ScanData2202_ *from, struct _ibeo_msgs_msg_dds__ScanData2202_ *to);
extern  void __ibeo_msgs_msg_dds__ScanData2202___copyOut(const void *_from, void *_to);
struct _ibeo_msgs_msg_dds__ScanData2202_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _ibeo_msgs_msg_dds__IbeoDataHeader_ ibeo_header_;
    c_ushort scan_number_;
    c_ushort scanner_status_;
    c_ushort sync_phase_offset_;
    struct _builtin_interfaces_msg_dds__Time_ scan_start_time_;
    struct _builtin_interfaces_msg_dds__Time_ scan_end_time_;
    c_ushort angle_ticks_per_rotation_;
    c_short start_angle_ticks_;
    c_short end_angle_ticks_;
    c_ushort scan_points_count_;
    c_short mounting_yaw_angle_ticks_;
    c_short mounting_pitch_angle_ticks_;
    c_short mounting_roll_angle_ticks_;
    c_short mounting_position_x_;
    c_short mounting_position_y_;
    c_short mounting_position_z_;
    c_bool ground_labeled_;
    c_bool dirt_labeled_;
    c_bool rain_labeled_;
    c_octet mirror_side_;
    c_sequence scan_point_list_;
};

#undef OS_API
#endif
