#ifndef _H_DFA1914392EBA6FD95BB980BD1291046_ScanData2204__H_
#define _H_DFA1914392EBA6FD95BB980BD1291046_ScanData2204__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"
#include "ibeo_msgs/msg/dds_opensplice/ScannerInfo2204_.h"
#include "ibeo_msgs/msg/dds_opensplice/ScanPoint2204_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ScanData2204_Constants
            {
                const ::DDS::Octet FRONT_ = 0;

                const ::DDS::Octet REAR_ = 1;

                const ::DDS::Octet SCANNER_ = 0;

                const ::DDS::Octet VEHICLE_ = 1;

            }

            struct  ScanData2204_
            {
                struct _scanner_info_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::ScannerInfo2204_, struct _scanner_info_list__seq_uniq_ > _scanner_info_list__seq;
                typedef DDS_DCPSSequence_var< _scanner_info_list__seq > _scanner_info_list__seq_var;
                typedef DDS_DCPSSequence_out< _scanner_info_list__seq > _scanner_info_list__seq_out;
                struct _scan_point_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::ScanPoint2204_, struct _scan_point_list__seq_uniq_ > _scan_point_list__seq;
                typedef DDS_DCPSSequence_var< _scan_point_list__seq > _scan_point_list__seq_var;
                typedef DDS_DCPSSequence_out< _scan_point_list__seq > _scan_point_list__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::DDS::ULongLong scan_start_time_;
                ::DDS::ULong scan_end_time_offset_;
                ::DDS::Boolean ground_labeled_;
                ::DDS::Boolean dirt_labeled_;
                ::DDS::Boolean rain_labeled_;
                ::DDS::Boolean fused_scan_;
                ::DDS::Octet mirror_side_;
                ::DDS::Octet coordinate_system_;
                ::DDS::UShort scan_number_;
                ::DDS::UShort scan_points_;
                ::DDS::UShort number_of_scanner_infos_;
                _scanner_info_list__seq scanner_info_list_;
                _scan_point_list__seq scan_point_list_;
            };

            typedef DDS_DCPSStruct_var<ScanData2204_> ScanData2204__var;
            typedef DDS_DCPSStruct_out < ScanData2204_> ScanData2204__out;

        }

    }

}

#endif /* _H_DFA1914392EBA6FD95BB980BD1291046_ScanData2204__H_ */
