#ifndef _H_DFA1914392EBA6FD95BB980BD1291046_ScanData2204_DCPS_H_
#define _H_DFA1914392EBA6FD95BB980BD1291046_ScanData2204_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScanData2204_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScanData2204_TypeSupportInterface;

            typedef ScanData2204_TypeSupportInterface * ScanData2204_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScanData2204_TypeSupportInterface> ScanData2204_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScanData2204_TypeSupportInterface> ScanData2204_TypeSupportInterface_out;


            class ScanData2204_DataWriter;

            typedef ScanData2204_DataWriter * ScanData2204_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScanData2204_DataWriter> ScanData2204_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScanData2204_DataWriter> ScanData2204_DataWriter_out;


            class ScanData2204_DataReader;

            typedef ScanData2204_DataReader * ScanData2204_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScanData2204_DataReader> ScanData2204_DataReader_var;
            typedef DDS_DCPSInterface_out < ScanData2204_DataReader> ScanData2204_DataReader_out;


            class ScanData2204_DataReaderView;

            typedef ScanData2204_DataReaderView * ScanData2204_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScanData2204_DataReaderView> ScanData2204_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScanData2204_DataReaderView> ScanData2204_DataReaderView_out;

            struct ScanData2204_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ScanData2204_, struct ScanData2204_Seq_uniq_> ScanData2204_Seq;
            typedef DDS_DCPSSequence_var < ScanData2204_Seq> ScanData2204_Seq_var;
            typedef DDS_DCPSSequence_out < ScanData2204_Seq> ScanData2204_Seq_out;

            class  ScanData2204_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScanData2204_TypeSupportInterface_ptr _ptr_type;
                typedef ScanData2204_TypeSupportInterface_var _var_type;

                static ScanData2204_TypeSupportInterface_ptr _duplicate (ScanData2204_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2204_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2204_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2204_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2204_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScanData2204_TypeSupportInterface () {};
                ~ScanData2204_TypeSupportInterface () {};
            private:
                ScanData2204_TypeSupportInterface (const ScanData2204_TypeSupportInterface &);
                ScanData2204_TypeSupportInterface & operator = (const ScanData2204_TypeSupportInterface &);
            };

            class  ScanData2204_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScanData2204_DataWriter_ptr _ptr_type;
                typedef ScanData2204_DataWriter_var _var_type;

                static ScanData2204_DataWriter_ptr _duplicate (ScanData2204_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2204_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2204_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2204_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2204_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScanData2204_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScanData2204_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScanData2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScanData2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScanData2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScanData2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScanData2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScanData2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScanData2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScanData2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScanData2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2204_& instance_data) = 0;

            protected:
                ScanData2204_DataWriter () {};
                ~ScanData2204_DataWriter () {};
            private:
                ScanData2204_DataWriter (const ScanData2204_DataWriter &);
                ScanData2204_DataWriter & operator = (const ScanData2204_DataWriter &);
            };

            class  ScanData2204_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScanData2204_DataReader_ptr _ptr_type;
                typedef ScanData2204_DataReader_var _var_type;

                static ScanData2204_DataReader_ptr _duplicate (ScanData2204_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2204_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2204_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2204_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2204_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2204_& instance) = 0;

            protected:
                ScanData2204_DataReader () {};
                ~ScanData2204_DataReader () {};
            private:
                ScanData2204_DataReader (const ScanData2204_DataReader &);
                ScanData2204_DataReader & operator = (const ScanData2204_DataReader &);
            };

            class  ScanData2204_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScanData2204_DataReaderView_ptr _ptr_type;
                typedef ScanData2204_DataReaderView_var _var_type;

                static ScanData2204_DataReaderView_ptr _duplicate (ScanData2204_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2204_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2204_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2204_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2204_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2204_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2204_& instance) = 0;

            protected:
                ScanData2204_DataReaderView () {};
                ~ScanData2204_DataReaderView () {};
            private:
                ScanData2204_DataReaderView (const ScanData2204_DataReaderView &);
                ScanData2204_DataReaderView & operator = (const ScanData2204_DataReaderView &);
            };
        }

    }

}

#endif
