#ifndef _H_B93970D2ABD1B017B1A6783F79549680_ScanData2205__H_
#define _H_B93970D2ABD1B017B1A6783F79549680_ScanData2205__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "ibeo_msgs/msg/dds_opensplice/ScannerInfo2205_.h"
#include "ibeo_msgs/msg/dds_opensplice/ScanPoint2205_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ScanData2205_Constants
            {
                const ::DDS::Octet FRONT_ = 0;

                const ::DDS::Octet REAR_ = 1;

                const ::DDS::Octet SCANNER_ = 0;

                const ::DDS::Octet VEHICLE_ = 1;

            }

            struct  ScanData2205_
            {
                struct _scanner_info_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::ScannerInfo2205_, struct _scanner_info_list__seq_uniq_ > _scanner_info_list__seq;
                typedef DDS_DCPSSequence_var< _scanner_info_list__seq > _scanner_info_list__seq_var;
                typedef DDS_DCPSSequence_out< _scanner_info_list__seq > _scanner_info_list__seq_out;
                struct _scan_point_list__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::ibeo_msgs::msg::dds_::ScanPoint2205_, struct _scan_point_list__seq_uniq_ > _scan_point_list__seq;
                typedef DDS_DCPSSequence_var< _scan_point_list__seq > _scan_point_list__seq_var;
                typedef DDS_DCPSSequence_out< _scan_point_list__seq > _scan_point_list__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::ibeo_msgs::msg::dds_::IbeoDataHeader_ ibeo_header_;
                ::builtin_interfaces::msg::dds_::Time_ scan_start_time_;
                ::DDS::Octet scan_end_time_offset_;
                ::DDS::Boolean fused_scan_;
                ::DDS::Octet mirror_side_;
                ::DDS::Octet coordinate_system_;
                ::DDS::UShort scan_number_;
                ::DDS::UShort scan_points_;
                ::DDS::Octet number_of_scanner_infos_;
                _scanner_info_list__seq scanner_info_list_;
                _scan_point_list__seq scan_point_list_;
            };

            typedef DDS_DCPSStruct_var<ScanData2205_> ScanData2205__var;
            typedef DDS_DCPSStruct_out < ScanData2205_> ScanData2205__out;

        }

    }

}

#endif /* _H_B93970D2ABD1B017B1A6783F79549680_ScanData2205__H_ */
