#ifndef _H_B93970D2ABD1B017B1A6783F79549680_ScanData2205_DCPS_H_
#define _H_B93970D2ABD1B017B1A6783F79549680_ScanData2205_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScanData2205_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScanData2205_TypeSupportInterface;

            typedef ScanData2205_TypeSupportInterface * ScanData2205_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScanData2205_TypeSupportInterface> ScanData2205_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScanData2205_TypeSupportInterface> ScanData2205_TypeSupportInterface_out;


            class ScanData2205_DataWriter;

            typedef ScanData2205_DataWriter * ScanData2205_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScanData2205_DataWriter> ScanData2205_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScanData2205_DataWriter> ScanData2205_DataWriter_out;


            class ScanData2205_DataReader;

            typedef ScanData2205_DataReader * ScanData2205_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScanData2205_DataReader> ScanData2205_DataReader_var;
            typedef DDS_DCPSInterface_out < ScanData2205_DataReader> ScanData2205_DataReader_out;


            class ScanData2205_DataReaderView;

            typedef ScanData2205_DataReaderView * ScanData2205_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScanData2205_DataReaderView> ScanData2205_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScanData2205_DataReaderView> ScanData2205_DataReaderView_out;

            struct ScanData2205_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ScanData2205_, struct ScanData2205_Seq_uniq_> ScanData2205_Seq;
            typedef DDS_DCPSSequence_var < ScanData2205_Seq> ScanData2205_Seq_var;
            typedef DDS_DCPSSequence_out < ScanData2205_Seq> ScanData2205_Seq_out;

            class  ScanData2205_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScanData2205_TypeSupportInterface_ptr _ptr_type;
                typedef ScanData2205_TypeSupportInterface_var _var_type;

                static ScanData2205_TypeSupportInterface_ptr _duplicate (ScanData2205_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2205_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2205_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2205_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2205_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScanData2205_TypeSupportInterface () {};
                ~ScanData2205_TypeSupportInterface () {};
            private:
                ScanData2205_TypeSupportInterface (const ScanData2205_TypeSupportInterface &);
                ScanData2205_TypeSupportInterface & operator = (const ScanData2205_TypeSupportInterface &);
            };

            class  ScanData2205_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScanData2205_DataWriter_ptr _ptr_type;
                typedef ScanData2205_DataWriter_var _var_type;

                static ScanData2205_DataWriter_ptr _duplicate (ScanData2205_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2205_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2205_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2205_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2205_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScanData2205_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScanData2205_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScanData2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScanData2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScanData2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScanData2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScanData2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScanData2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScanData2205_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScanData2205_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScanData2205_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2205_& instance_data) = 0;

            protected:
                ScanData2205_DataWriter () {};
                ~ScanData2205_DataWriter () {};
            private:
                ScanData2205_DataWriter (const ScanData2205_DataWriter &);
                ScanData2205_DataWriter & operator = (const ScanData2205_DataWriter &);
            };

            class  ScanData2205_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScanData2205_DataReader_ptr _ptr_type;
                typedef ScanData2205_DataReader_var _var_type;

                static ScanData2205_DataReader_ptr _duplicate (ScanData2205_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2205_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2205_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2205_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2205_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2205_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2205_& instance) = 0;

            protected:
                ScanData2205_DataReader () {};
                ~ScanData2205_DataReader () {};
            private:
                ScanData2205_DataReader (const ScanData2205_DataReader &);
                ScanData2205_DataReader & operator = (const ScanData2205_DataReader &);
            };

            class  ScanData2205_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScanData2205_DataReaderView_ptr _ptr_type;
                typedef ScanData2205_DataReaderView_var _var_type;

                static ScanData2205_DataReaderView_ptr _duplicate (ScanData2205_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanData2205_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScanData2205_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanData2205_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanData2205_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanData2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanData2205_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanData2205_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanData2205_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanData2205_& instance) = 0;

            protected:
                ScanData2205_DataReaderView () {};
                ~ScanData2205_DataReaderView () {};
            private:
                ScanData2205_DataReaderView (const ScanData2205_DataReaderView &);
                ScanData2205_DataReaderView & operator = (const ScanData2205_DataReaderView &);
            };
        }

    }

}

#endif
