#ifndef H_3E9E74F479D39DAFC7CC6E19FAFA960E_ScanData2208_SPLTYPES_H
#define H_3E9E74F479D39DAFC7CC6E19FAFA960E_ScanData2208_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ScanData2208_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/IbeoDataHeader_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/ScanPoint2208_SplDcps.h"



extern c_metaObject __ScanData2208__ibeo_msgs__load (c_base base);

extern c_metaObject __ScanData2208__ibeo_msgs_msg__load (c_base base);

extern c_metaObject __ScanData2208__ibeo_msgs_msg_dds___load (c_base base);

extern c_metaObject __ScanData2208__ibeo_msgs_msg_dds__ScanData2208_Constants__load (c_base base);

extern const char *ibeo_msgs_msg_dds__ScanData2208__metaDescriptor[];
extern const int ibeo_msgs_msg_dds__ScanData2208__metaDescriptorArrLength;
extern const int ibeo_msgs_msg_dds__ScanData2208__metaDescriptorLength;
extern c_metaObject __ibeo_msgs_msg_dds__ScanData2208___load (c_base base);
struct _ibeo_msgs_msg_dds__ScanData2208_ ;
extern  v_copyin_result __ibeo_msgs_msg_dds__ScanData2208___copyIn(c_base base, const struct ibeo_msgs::msg::dds_::ScanData2208_ *from, struct _ibeo_msgs_msg_dds__ScanData2208_ *to);
extern  void __ibeo_msgs_msg_dds__ScanData2208___copyOut(const void *_from, void *_to);
struct _ibeo_msgs_msg_dds__ScanData2208_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _ibeo_msgs_msg_dds__IbeoDataHeader_ ibeo_header_;
    c_ushort scan_number_;
    c_ushort scanner_type_;
    c_bool motor_on_;
    c_bool laser_on_;
    c_bool frequency_locked_;
    c_octet motor_rotating_direction_;
    c_ushort angle_ticks_per_rotation_;
    c_ulong scan_flags_;
    c_short mounting_yaw_angle_ticks_;
    c_short mounting_pitch_angle_ticks_;
    c_short mounting_roll_angle_ticks_;
    c_short mounting_position_x_;
    c_short mounting_position_y_;
    c_short mounting_position_z_;
    c_octet device_id_;
    struct _builtin_interfaces_msg_dds__Time_ scan_start_time_;
    struct _builtin_interfaces_msg_dds__Time_ scan_end_time_;
    c_short start_angle_ticks_;
    c_short end_angle_ticks_;
    c_octet mirror_side_;
    c_short mirror_tilt_;
    c_sequence scan_point_list_;
};

#undef OS_API
#endif
