#ifndef _H_94645D8BE3CAC1C81B5C9A48314CD609_ScanPoint2204_DCPS_H_
#define _H_94645D8BE3CAC1C81B5C9A48314CD609_ScanPoint2204_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScanPoint2204_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScanPoint2204_TypeSupportInterface;

            typedef ScanPoint2204_TypeSupportInterface * ScanPoint2204_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2204_TypeSupportInterface> ScanPoint2204_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScanPoint2204_TypeSupportInterface> ScanPoint2204_TypeSupportInterface_out;


            class ScanPoint2204_DataWriter;

            typedef ScanPoint2204_DataWriter * ScanPoint2204_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2204_DataWriter> ScanPoint2204_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScanPoint2204_DataWriter> ScanPoint2204_DataWriter_out;


            class ScanPoint2204_DataReader;

            typedef ScanPoint2204_DataReader * ScanPoint2204_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2204_DataReader> ScanPoint2204_DataReader_var;
            typedef DDS_DCPSInterface_out < ScanPoint2204_DataReader> ScanPoint2204_DataReader_out;


            class ScanPoint2204_DataReaderView;

            typedef ScanPoint2204_DataReaderView * ScanPoint2204_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScanPoint2204_DataReaderView> ScanPoint2204_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScanPoint2204_DataReaderView> ScanPoint2204_DataReaderView_out;

            struct ScanPoint2204_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ScanPoint2204_, struct ScanPoint2204_Seq_uniq_> ScanPoint2204_Seq;
            typedef DDS_DCPSSequence_var < ScanPoint2204_Seq> ScanPoint2204_Seq_var;
            typedef DDS_DCPSSequence_out < ScanPoint2204_Seq> ScanPoint2204_Seq_out;

            class  ScanPoint2204_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScanPoint2204_TypeSupportInterface_ptr _ptr_type;
                typedef ScanPoint2204_TypeSupportInterface_var _var_type;

                static ScanPoint2204_TypeSupportInterface_ptr _duplicate (ScanPoint2204_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2204_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2204_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2204_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2204_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScanPoint2204_TypeSupportInterface () {};
                ~ScanPoint2204_TypeSupportInterface () {};
            private:
                ScanPoint2204_TypeSupportInterface (const ScanPoint2204_TypeSupportInterface &);
                ScanPoint2204_TypeSupportInterface & operator = (const ScanPoint2204_TypeSupportInterface &);
            };

            class  ScanPoint2204_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScanPoint2204_DataWriter_ptr _ptr_type;
                typedef ScanPoint2204_DataWriter_var _var_type;

                static ScanPoint2204_DataWriter_ptr _duplicate (ScanPoint2204_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2204_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2204_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2204_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2204_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScanPoint2204_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScanPoint2204_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScanPoint2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScanPoint2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScanPoint2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScanPoint2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScanPoint2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScanPoint2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScanPoint2204_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScanPoint2204_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScanPoint2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanPoint2204_& instance_data) = 0;

            protected:
                ScanPoint2204_DataWriter () {};
                ~ScanPoint2204_DataWriter () {};
            private:
                ScanPoint2204_DataWriter (const ScanPoint2204_DataWriter &);
                ScanPoint2204_DataWriter & operator = (const ScanPoint2204_DataWriter &);
            };

            class  ScanPoint2204_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScanPoint2204_DataReader_ptr _ptr_type;
                typedef ScanPoint2204_DataReader_var _var_type;

                static ScanPoint2204_DataReader_ptr _duplicate (ScanPoint2204_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2204_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2204_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2204_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2204_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanPoint2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanPoint2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanPoint2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanPoint2204_& instance) = 0;

            protected:
                ScanPoint2204_DataReader () {};
                ~ScanPoint2204_DataReader () {};
            private:
                ScanPoint2204_DataReader (const ScanPoint2204_DataReader &);
                ScanPoint2204_DataReader & operator = (const ScanPoint2204_DataReader &);
            };

            class  ScanPoint2204_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScanPoint2204_DataReaderView_ptr _ptr_type;
                typedef ScanPoint2204_DataReaderView_var _var_type;

                static ScanPoint2204_DataReaderView_ptr _duplicate (ScanPoint2204_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanPoint2204_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScanPoint2204_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanPoint2204_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanPoint2204_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanPoint2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanPoint2204_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanPoint2204_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanPoint2204_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanPoint2204_& instance) = 0;

            protected:
                ScanPoint2204_DataReaderView () {};
                ~ScanPoint2204_DataReaderView () {};
            private:
                ScanPoint2204_DataReaderView (const ScanPoint2204_DataReaderView &);
                ScanPoint2204_DataReaderView & operator = (const ScanPoint2204_DataReaderView &);
            };
        }

    }

}

#endif
