#ifndef H_D3C27647F383A36E1299DD652E1BCFF7_ScannerInfo2205_SPLTYPES_H
#define H_D3C27647F383A36E1299DD652E1BCFF7_ScannerInfo2205_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ScannerInfo2205_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/MountingPositionF_SplDcps.h"
#include "ibeo_msgs/msg/dds_opensplice/ResolutionInfo_SplDcps.h"



extern c_metaObject __ScannerInfo2205__ibeo_msgs__load (c_base base);

extern c_metaObject __ScannerInfo2205__ibeo_msgs_msg__load (c_base base);

extern c_metaObject __ScannerInfo2205__ibeo_msgs_msg_dds___load (c_base base);

extern c_metaObject __ScannerInfo2205__ibeo_msgs_msg_dds__ScannerInfo2205_Constants__load (c_base base);

extern const char *ibeo_msgs_msg_dds__ScannerInfo2205__metaDescriptor[];
extern const int ibeo_msgs_msg_dds__ScannerInfo2205__metaDescriptorArrLength;
extern const int ibeo_msgs_msg_dds__ScannerInfo2205__metaDescriptorLength;
extern c_metaObject __ibeo_msgs_msg_dds__ScannerInfo2205___load (c_base base);
struct _ibeo_msgs_msg_dds__ScannerInfo2205_ ;
extern  v_copyin_result __ibeo_msgs_msg_dds__ScannerInfo2205___copyIn(c_base base, const struct ibeo_msgs::msg::dds_::ScannerInfo2205_ *from, struct _ibeo_msgs_msg_dds__ScannerInfo2205_ *to);
extern  void __ibeo_msgs_msg_dds__ScannerInfo2205___copyOut(const void *_from, void *_to);
struct _ibeo_msgs_msg_dds__ScannerInfo2205_ {
    c_octet device_id_;
    c_octet scanner_type_;
    c_ushort scan_number_;
    c_float start_angle_;
    c_float end_angle_;
    struct _builtin_interfaces_msg_dds__Time_ scan_start_time_;
    struct _builtin_interfaces_msg_dds__Time_ scan_end_time_;
    struct _builtin_interfaces_msg_dds__Time_ scan_start_time_from_device_;
    struct _builtin_interfaces_msg_dds__Time_ scan_end_time_from_device_;
    c_float scan_frequency_;
    c_float beam_tilt_;
    c_ulong scan_flags_;
    struct _ibeo_msgs_msg_dds__MountingPositionF_ mounting_position_;
    struct _ibeo_msgs_msg_dds__ResolutionInfo_ resolutions_[8];
};

#undef OS_API
#endif
