#ifndef _H_B45E4FFDB0924C714504F5B61568E312_TrackedProperties_DCPS_H_
#define _H_B45E4FFDB0924C714504F5B61568E312_TrackedProperties_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TrackedProperties_.h"


namespace ibeo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TrackedProperties_TypeSupportInterface;

            typedef TrackedProperties_TypeSupportInterface * TrackedProperties_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TrackedProperties_TypeSupportInterface> TrackedProperties_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TrackedProperties_TypeSupportInterface> TrackedProperties_TypeSupportInterface_out;


            class TrackedProperties_DataWriter;

            typedef TrackedProperties_DataWriter * TrackedProperties_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TrackedProperties_DataWriter> TrackedProperties_DataWriter_var;
            typedef DDS_DCPSInterface_out < TrackedProperties_DataWriter> TrackedProperties_DataWriter_out;


            class TrackedProperties_DataReader;

            typedef TrackedProperties_DataReader * TrackedProperties_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TrackedProperties_DataReader> TrackedProperties_DataReader_var;
            typedef DDS_DCPSInterface_out < TrackedProperties_DataReader> TrackedProperties_DataReader_out;


            class TrackedProperties_DataReaderView;

            typedef TrackedProperties_DataReaderView * TrackedProperties_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TrackedProperties_DataReaderView> TrackedProperties_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TrackedProperties_DataReaderView> TrackedProperties_DataReaderView_out;

            struct TrackedProperties_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TrackedProperties_, struct TrackedProperties_Seq_uniq_> TrackedProperties_Seq;
            typedef DDS_DCPSSequence_var < TrackedProperties_Seq> TrackedProperties_Seq_var;
            typedef DDS_DCPSSequence_out < TrackedProperties_Seq> TrackedProperties_Seq_out;

            class  TrackedProperties_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TrackedProperties_TypeSupportInterface_ptr _ptr_type;
                typedef TrackedProperties_TypeSupportInterface_var _var_type;

                static TrackedProperties_TypeSupportInterface_ptr _duplicate (TrackedProperties_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedProperties_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TrackedProperties_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedProperties_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedProperties_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TrackedProperties_TypeSupportInterface () {};
                ~TrackedProperties_TypeSupportInterface () {};
            private:
                TrackedProperties_TypeSupportInterface (const TrackedProperties_TypeSupportInterface &);
                TrackedProperties_TypeSupportInterface & operator = (const TrackedProperties_TypeSupportInterface &);
            };

            class  TrackedProperties_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TrackedProperties_DataWriter_ptr _ptr_type;
                typedef TrackedProperties_DataWriter_var _var_type;

                static TrackedProperties_DataWriter_ptr _duplicate (TrackedProperties_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedProperties_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TrackedProperties_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedProperties_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedProperties_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TrackedProperties_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TrackedProperties_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TrackedProperties_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TrackedProperties_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TrackedProperties_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackedProperties_& instance_data) = 0;

            protected:
                TrackedProperties_DataWriter () {};
                ~TrackedProperties_DataWriter () {};
            private:
                TrackedProperties_DataWriter (const TrackedProperties_DataWriter &);
                TrackedProperties_DataWriter & operator = (const TrackedProperties_DataWriter &);
            };

            class  TrackedProperties_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TrackedProperties_DataReader_ptr _ptr_type;
                typedef TrackedProperties_DataReader_var _var_type;

                static TrackedProperties_DataReader_ptr _duplicate (TrackedProperties_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedProperties_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TrackedProperties_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedProperties_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedProperties_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackedProperties_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackedProperties_& instance) = 0;

            protected:
                TrackedProperties_DataReader () {};
                ~TrackedProperties_DataReader () {};
            private:
                TrackedProperties_DataReader (const TrackedProperties_DataReader &);
                TrackedProperties_DataReader & operator = (const TrackedProperties_DataReader &);
            };

            class  TrackedProperties_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TrackedProperties_DataReaderView_ptr _ptr_type;
                typedef TrackedProperties_DataReaderView_var _var_type;

                static TrackedProperties_DataReaderView_ptr _duplicate (TrackedProperties_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedProperties_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TrackedProperties_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedProperties_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedProperties_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackedProperties_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackedProperties_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackedProperties_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackedProperties_& instance) = 0;

            protected:
                TrackedProperties_DataReaderView () {};
                ~TrackedProperties_DataReaderView () {};
            private:
                TrackedProperties_DataReaderView (const TrackedProperties_DataReaderView &);
                TrackedProperties_DataReaderView & operator = (const TrackedProperties_DataReaderView &);
            };
        }

    }

}

#endif
