// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/ObjectData2271.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/object_data2271__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `ibeo_header`
#include "ibeo_msgs/msg/ibeo_data_header__functions.h"
// Member `start_scan_timestamp`
#include "builtin_interfaces/msg/time__functions.h"
// Member `object_list`
#include "ibeo_msgs/msg/object2271__functions.h"

bool
ibeo_msgs__msg__ObjectData2271__init(ibeo_msgs__msg__ObjectData2271 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ibeo_msgs__msg__ObjectData2271__fini(msg);
    return false;
  }
  // ibeo_header
  if (!ibeo_msgs__msg__IbeoDataHeader__init(&msg->ibeo_header)) {
    ibeo_msgs__msg__ObjectData2271__fini(msg);
    return false;
  }
  // start_scan_timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->start_scan_timestamp)) {
    ibeo_msgs__msg__ObjectData2271__fini(msg);
    return false;
  }
  // scan_number
  // number_of_objects
  // object_list
  if (!ibeo_msgs__msg__Object2271__Sequence__init(&msg->object_list, 0)) {
    ibeo_msgs__msg__ObjectData2271__fini(msg);
    return false;
  }
  return true;
}

void
ibeo_msgs__msg__ObjectData2271__fini(ibeo_msgs__msg__ObjectData2271 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ibeo_header
  ibeo_msgs__msg__IbeoDataHeader__fini(&msg->ibeo_header);
  // start_scan_timestamp
  builtin_interfaces__msg__Time__fini(&msg->start_scan_timestamp);
  // scan_number
  // number_of_objects
  // object_list
  ibeo_msgs__msg__Object2271__Sequence__fini(&msg->object_list);
}

ibeo_msgs__msg__ObjectData2271 *
ibeo_msgs__msg__ObjectData2271__create()
{
  ibeo_msgs__msg__ObjectData2271 * msg = (ibeo_msgs__msg__ObjectData2271 *)malloc(sizeof(ibeo_msgs__msg__ObjectData2271));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__ObjectData2271));
  bool success = ibeo_msgs__msg__ObjectData2271__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__ObjectData2271__destroy(ibeo_msgs__msg__ObjectData2271 * msg)
{
  if (msg) {
    ibeo_msgs__msg__ObjectData2271__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__ObjectData2271__Sequence__init(ibeo_msgs__msg__ObjectData2271__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__ObjectData2271 * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__ObjectData2271 *)calloc(size, sizeof(ibeo_msgs__msg__ObjectData2271));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__ObjectData2271__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__ObjectData2271__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__ObjectData2271__Sequence__fini(ibeo_msgs__msg__ObjectData2271__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__ObjectData2271__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__ObjectData2271__Sequence *
ibeo_msgs__msg__ObjectData2271__Sequence__create(size_t size)
{
  ibeo_msgs__msg__ObjectData2271__Sequence * array = (ibeo_msgs__msg__ObjectData2271__Sequence *)malloc(sizeof(ibeo_msgs__msg__ObjectData2271__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__ObjectData2271__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__ObjectData2271__Sequence__destroy(ibeo_msgs__msg__ObjectData2271__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__ObjectData2271__Sequence__fini(array);
  }
  free(array);
}
